<?xml version="1.0" encoding="utf-8"?>

<!DOCTYPE xsl:stylesheet  [
<!ENTITY nbsp   "&#160;">
<!ENTITY copy   "&#169;">
<!ENTITY reg    "&#174;">
<!ENTITY trade  "&#8482;">
<!ENTITY mdash  "&#8212;">
<!ENTITY ldquo  "&#8220;">
<!ENTITY rdquo  "&#8221;">
<!ENTITY pound  "&#163;">
<!ENTITY yen    "&#165;">
<!ENTITY euro   "&#8364;">
<!ENTITY emsp   "&#8195;">
]>

<xsl:stylesheet version="1.0" 
	xmlns:cr="https://allseenalliance.org/schemas/extended_introspect"
	xmlns:xsl="http://www.w3.org/1999/XSL/Transform">
	<xsl:output	method="html" encoding="utf-8" doctype-public="-//W3C//DTD XHTML 1.0 Transitional//EN" doctype-system="http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd"/>
	
	<!-- INCLUDE D-BUS TYPES -->
	<xsl:variable name="dbus_types" select="document('org.freedesktop.DBus.Types.xml')/node/type" />
	
	<xsl:template match="/">		
	<html xmlns="http://www.w3.org/1999/xhtml">
		<head>
			<meta http-equiv="Content-Type" content="text/html; charset=utf-8" />
			<title>
				<xsl:value-of select="/cr:node/cr:interface/@name"/>
			</title>
	<link rel="icon" href="images/favicon.ico" type="image/x-icon" />
	<link rel="shortcut icon" href="images/favicon.ico" type="image/x-icon" /> 		
    <script src="https://ajax.googleapis.com/ajax/libs/jquery/1.11.3/jquery.min.js"></script>
    <script>
    <![CDATA[
$(document).ready(function() {
    /* get all lang attribute values and remove duplicates */
    var langValues = [];
    $("[lang]").each(function() {
    	langValues.push($(this).attr("lang"))
    });
   
    /* this works in mozilla and IE when removing duplicates in array */
	var uniqueLangValues = [];
	$.each(langValues, function(i, el){
	    if($.inArray(el, uniqueLangValues) === -1) uniqueLangValues.push(el);
	});   
	    
    /* build actual dropdown menu */
    var selectedAttr = "";
    $.each(uniqueLangValues, function(index, value) {
        if(value === "en")
    		selectedAttr = " selected='selected'";
        else
            selectedAttr = "";

    	$("#language").append("<option value=" + value + selectedAttr + ">" + value + "</option>");
    });
    
	/* expand/collapse */
	$('.panel-36').hide();
	$('.toggler-36').click(function()
	{
		$(this).next('.panel-36').slideToggle(600);
	});
	
	/* show English only as default */
	$("[lang]").hide();	
	$("[lang='en']").show();
	
	/* hide-show by lang attribute from selection */
	$('#language').change(
    function()
    {
		/* storing the language chosen in the select element */
		var v = this.value;
		/* iterates over all elements with lang attribute, and hides them,
		   then filters the matched elements to see which elements
		   contain the relevant language in the 'lang' attribute: */
		$("[lang]").hide().filter(
			function()
			{
				var langAttr = this.getAttribute('lang');
				var isLangFound = langAttr.indexOf(v);
				/* shows the elements that contain the relevant language: */
				
				if(isLangFound===-1)
					return false;
				
				return true;
			}
		).show(); 
    });
});
    ]]>
    </script>
    
    		<script src="dynamic_URLs.js" type="text/javascript">
			</script>
    		<link rel="stylesheet" type="text/css" href="main.css"></link>
    	</head>

		<body onload="onLoadFunction()">

				<!-- start .container  -->
				<div class="container">

					<!-- start .header -->
					<div class="header">
						<a href="#" id="home_url">
							<img class="logo"/>
						</a>
						<span class="header_menu">
							<label for="language">Lang:</label>
							<select name="language" id="language">
							</select>
							&nbsp;
							<a href="#" id="xml_url" class="htmlTransl" target="_blank">XML</a> &nbsp;
							<a href="#" id="java_url" class="htmlTransl">Java</a> &nbsp;
							<a href="#" id="html_url" class="htmlTransl">HTML</a> &nbsp;
						</span>
					<!-- end .header -->
					</div>

					<!-- start .content  -->
					<div class="content">
						<h1>Allseen Repository</h1> 
						<h2>Node: <xsl:value-of select="/cr:node/@name"/></h2>
						<xsl:apply-templates select="/cr:node/cr:interface"/>
					<!-- end .content  -->
					</div>
					<div class="footer">
						<p></p>
					<!-- end .footer -->
					</div>

				<!-- end .container  -->
				</div>
			</body>
		</html>
	</xsl:template>

	<!-- SUB-TEMPLATE DEFINITIONS -->
	<!-- INTERFACES -->
	<xsl:template match="cr:node/cr:interface">
		<div class="interface">
			<hr />
			<!-- INTERFACE NAME -->
			<span class="interfaceTitle">
				Interface: <xsl:value-of select="@name"/>
			</span>
			<!-- INTERFACE DESCRIPTION -->
			<br />
			<xsl:apply-templates select="cr:description"/>
			<!-- PROPERTIES -->
			<xsl:if test="cr:property">
				<h3 class="toggler-36 sliderHeader">> Properties</h3>
	          	<div class="panel-36 expandedContent"> 
					<xsl:apply-templates select="cr:property"/>
				</div>
			</xsl:if>
			<!-- METHODS -->
			<xsl:if test="cr:method">
				<h3 class="toggler-36 sliderHeader">> Methods</h3>
	          	<div class="panel-36 expandedContent"> 
					<xsl:apply-templates select="cr:method"/>
				</div>
			</xsl:if>
			<!-- STRUCTURES -->
			<xsl:if test="cr:struct">
				<h3 class="toggler-36 sliderHeader">> Structures</h3>
	          	<div class="panel-36 expandedContent"> 
					<xsl:apply-templates select="cr:struct"/>
				</div>
			</xsl:if>
			<!-- SIGNALS -->
			<xsl:if test="cr:signal">
				<h3 class="toggler-36 sliderHeader">> Signals</h3>
	          	<div class="panel-36 expandedContent"> 
					<xsl:apply-templates select="cr:signal"/>
				</div>
			</xsl:if>
			<!-- DICTIONARIES -->
			<xsl:if test="cr:dict">
				<h3 class="toggler-36 sliderHeader">> Dictionaries</h3>
	          	<div class="panel-36 expandedContent"> 
					<xsl:apply-templates select="cr:dict"/>
				</div>
			</xsl:if>
		</div>
	</xsl:template>

	<!-- PROPERTIES -->
	<xsl:template match="cr:property">       
		<span class="expandedItem">
			<!-- NAME -->
			<span class="name_allseen">
				<xsl:value-of select="@name"/>
			</span>
			
			<!-- DESCRIPTION -->
			<xsl:if test="cr:description">
				<br />
				<xsl:apply-templates select="cr:description"/>
			</xsl:if>
			<!-- TYPE -->
			<xsl:if test="@type">
				<br />
				Type:&nbsp;<xsl:value-of select="@type"/> - 
				<xsl:call-template name="simple_type">
			      <xsl:with-param name="type_var" select="@type" />
			    </xsl:call-template>
			</xsl:if>		
			<!-- ACCESS -->
			<xsl:if test="@access">
				<br />
				Access:&nbsp;
				<xsl:value-of select="@access" />
			</xsl:if>
		</span>
	</xsl:template>
	
	<!-- METHODS -->
	<xsl:template match="cr:method">       
		<span class="expandedItem">
			<!-- NAME -->
			<span class="name_allseen">
				<xsl:value-of select="@name"/>
			</span>
			
			<!-- DESCRIPTION -->
			<xsl:if test="cr:description">
				<br />
				<xsl:apply-templates select="cr:description"/>
			</xsl:if>
			<!-- ARGS -->
			<xsl:if test="cr:arg">
				<br />
				Args:&nbsp;<xsl:apply-templates select="cr:arg"/>
			</xsl:if>
		</span>
	</xsl:template>
	
	<!-- STRUCTURES -->
	<xsl:template match="cr:struct">       
		<span class="expandedItem">
			<!-- NAME -->
			<span class="name_allseen">
				<xsl:value-of select="@name"/>
			</span>
			
			<!-- DESCRIPTION -->
			<xsl:if test="cr:description">
				<br />
				<xsl:apply-templates select="cr:description"/>
			</xsl:if>
			<!-- FIELDS -->
			<xsl:if test="cr:field">
				<br />
				Fields:&nbsp;<xsl:apply-templates select="cr:field"/>
			</xsl:if>
		</span>
	</xsl:template>
	
	<!-- SIGNALS -->
	<xsl:template match="cr:signal">       
		<span class="expandedItem">
			<!-- NAME -->
			<span class="name_allseen">
				<xsl:value-of select="@name"/>
			</span>
			
			<!-- DESCRIPTION -->
			<xsl:if test="cr:description">
				<br />
				<xsl:apply-templates select="cr:description"/>
			</xsl:if>
			<!-- SESSIONLESS -->
			<xsl:if test="@sessionless">
				<br />
				Sessionless:&nbsp;<xsl:value-of select="@sessionless"/>
			</xsl:if>
			<!-- ARGS -->
			<xsl:if test="cr:arg">
				<br />
				Args:&nbsp;
				<xsl:apply-templates select="cr:arg"/>
			</xsl:if>
		</span>
	</xsl:template>
		
	<!-- DICTIONARIES -->
	<xsl:template match="cr:dict">       
		<span class="expandedItem">
			<!-- NAME -->
			<span class="name_allseen">
				<xsl:value-of select="@name"/>
			</span>
			
			<!-- DESCRIPTION -->
			<xsl:if test="cr:description">
				<br />
				<xsl:apply-templates select="cr:description"/>
			</xsl:if>
			<!-- KEY/VALUE -->
				<br />
				Key/Value:&nbsp;<br />
				<xsl:for-each select="*">
					<xsl:if test="local-name()='key'">
						&emsp; 
						<xsl:value-of select="@type"/> - 
						<xsl:call-template name="simple_type">
					      <xsl:with-param name="type_var" select="@type" />
					    </xsl:call-template> 
					 </xsl:if>
					 <xsl:if test="local-name()='value'">
						/				
						<xsl:value-of select="@type"/> - 
						<xsl:call-template name="simple_type">
					      <xsl:with-param name="type_var" select="@type" />
					    </xsl:call-template> 
					 </xsl:if>
					<br />
				</xsl:for-each>
		</span>
	</xsl:template>
	
	<!-- DESCRIPTION -->
	<xsl:template match="cr:description">
		<span class="description">
			<xsl:attribute name="lang">
				<xsl:value-of select="@language"/>
			</xsl:attribute>
			<xsl:value-of select="." disable-output-escaping="yes"/>
		</span>
	</xsl:template>
	
  <!-- ARGS -->
  <xsl:template match="cr:arg">
    <!-- NAME -->
    <xsl:if test="@name">
    	<br />
		<span class="name_allseen">
		&emsp;<xsl:value-of select="@name"/>
		</span>		
	</xsl:if>
	<!-- DESCRIPTION -->
	<xsl:if test="cr:description">
		<br />
		&emsp;<xsl:apply-templates select="cr:description"/>
	</xsl:if>
	<!-- TYPE -->
	<xsl:if test="@type">
		<br />
		&emsp;Type:&nbsp;<xsl:value-of select="@type"/> - 
		<xsl:call-template name="simple_type">
	      <xsl:with-param name="type_var" select="@type" />
	    </xsl:call-template> 
	</xsl:if>
	<!-- DIRECTION -->
	<xsl:if test="@direction">
		<br />
		&emsp;Direction:&nbsp;<xsl:value-of select="@direction"/>
	</xsl:if>
	<br />
  </xsl:template>
  
  <!-- FIELDS -->
  <xsl:template match="cr:field">
    <!-- NAME -->
    <xsl:if test="@name">
    	<br />
		<span class="name_allseen">
		&emsp;<xsl:value-of select="@name"/>
		</span>
		
	</xsl:if>
	<!-- DESCRIPTION -->
	<xsl:if test="cr:description">
		<br />
		&emsp;<xsl:apply-templates select="cr:description"/>
	</xsl:if>
	<!-- TYPE -->
	<xsl:if test="@type">
		<br />
		&emsp;Type:&nbsp;<xsl:value-of select="@type"/> - 
		<xsl:call-template name="simple_type">
	      <xsl:with-param name="type_var" select="@type" />
	    </xsl:call-template> 
	</xsl:if>
  </xsl:template>
  
  <!-- D-BUS TYPE MAPPING -->
  <xsl:template name="simple_type">  	
  	<xsl:param name="type_var" select="'Some text'" />
  	<xsl:if test="$type_var != ''">
	  	<xsl:variable name="letter" select="substring($type_var, 1, 1)" />
	  	<xsl:choose>
	  		<!-- ARRAY -->
	  		<xsl:when test="contains($letter,'a')">
	  			ARRAY 
	  			<xsl:call-template name="simple_type">
			      <xsl:with-param name="type_var" select="substring-after($type_var, $letter)" />
			    </xsl:call-template> 
	  		</xsl:when>
	  		<!-- STRUCTURE -->
	  		<xsl:when test="contains($letter,'r')">
	  			STRUCTURE
	  			<xsl:call-template name="simple_type">
			      <xsl:with-param name="type_var" select="substring-after($type_var, $letter)" />
			    </xsl:call-template>
	  		</xsl:when>
	  		<!-- DICT_ENTRY -->
	  		<xsl:when  test="contains($letter,'e')">
	  			DICT_ENTRY
	  			<xsl:call-template name="simple_type">
			      <xsl:with-param name="type_var" select="substring-after($type_var, $letter)" />
			    </xsl:call-template>
	  		</xsl:when>
	  		<!-- BRACKETS -->
	  		<xsl:when  test="contains($letter,'{') or contains($letter,'}') or contains($letter,'(') or contains($letter,')')">
	  			<xsl:value-of select="$letter" />&nbsp;
	  			<xsl:call-template name="simple_type">
			      <xsl:with-param name="type_var" select="substring-after($type_var, $letter)" />
			    </xsl:call-template>
	  		</xsl:when>
	  		<!-- SIMPLE TYPES -->
	  		<xsl:otherwise>
			  	<xsl:value-of select="$dbus_types[contains(@code, $letter)]/@name" />
			  	<xsl:if test="string-length($type_var) &gt; 2">
			  		,&nbsp;
			  	</xsl:if>
			  	<xsl:if test="string-length($type_var) = 2">
			  		&nbsp;
			  	</xsl:if>
			  	<xsl:call-template name="simple_type">
			      <xsl:with-param name="type_var" select="substring-after($type_var, $letter)" />
			    </xsl:call-template>
		  	</xsl:otherwise>
	  	</xsl:choose>	
  	</xsl:if>
  </xsl:template>
       
</xsl:stylesheet>