<?xml version="1.0" encoding="utf-8"?>

<!DOCTYPE xsl:stylesheet  [
	<!ENTITY nbsp   "&#160;">
	<!ENTITY copy   "&#169;">
	<!ENTITY reg    "&#174;">
	<!ENTITY trade  "&#8482;">
	<!ENTITY mdash  "&#8212;">
	<!ENTITY ldquo  "&#8220;">
	<!ENTITY rdquo  "&#8221;"> 
	<!ENTITY pound  "&#163;">
	<!ENTITY yen    "&#165;">
	<!ENTITY euro   "&#8364;">
    <!ENTITY emsp   "&#8195;">
]>

<xsl:stylesheet version="1.0"
	xmlns:xsl="http://www.w3.org/1999/XSL/Transform"
	xmlns:md="http://opendof.org/schema/interface-repository-meta"
    xmlns:cr="http://opendof.org/schema/interface-repository" 
    xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance">
  <xsl:output method="html" encoding="utf-8" doctype-public="-//W3C//DTD XHTML 1.0 Transitional//EN" doctype-system="http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd"/>
  <xsl:template match="/">
    <html xmlns="http://www.w3.org/1999/xhtml">
    <head>
    <meta http-equiv="Content-Type" content="text/html; charset=utf-8" />
    <title>
    	<xsl:choose>
		    <xsl:when test="/cr:interface/md:code-name">
		    	<xsl:value-of select="/cr:interface/md:code-name"/>
		    </xsl:when>
		    <xsl:otherwise>
            	<xsl:value-of select="/cr:interface/@iid"/>
            </xsl:otherwise>
    	</xsl:choose>
    	 - Java code
    </title>
    <link rel="icon" href="images/favicon.ico" type="image/x-icon" />
	<link rel="shortcut icon" href="images/favicon.ico" type="image/x-icon" /> 
    <script src="https://ajax.googleapis.com/ajax/libs/jquery/1.11.3/jquery.min.js"></script>
    <script>
    <![CDATA[
$(document).ready(function() {
    /* get all lang attribute values and remove duplicates */
    var langValues = [];
    $("[lang]").each(function() {
    	langValues.push($(this).attr("lang"))
    });
    var uniqueLangValues = $.unique(langValues);
    
    /* build actual dropdown menu */
    var selectedAttr = "";
    $.each(uniqueLangValues, function(index, value) {
        if(value === "en")
    		selectedAttr = " selected='selected'";
        else
            selectedAttr = "";

    	$("#language").append("<option value=" + value + selectedAttr + ">" + value + "</option>");
    });
    
	/* expand/collapse */
	$('.panel-36').hide();
	$('.toggler-36').click(function()
	{
		$(this).next('.panel-36').slideToggle(600);
	});
	
	/* show English only as default */
	$("[lang]").hide();	
	$("[lang='en']").show();
	
	/* hide-show by lang attribute from selection */
	$('#language').change(
    function()
    {
		/* storing the language chosen in the select element */
		var v = this.value;
		/* iterates over all elements with lang attribute, and hides them,
		   then filters the matched elements to see which elements
		   contain the relevant language in the 'lang' attribute: */
		$("[lang]").hide().filter(
			function()
			{
				var langAttr = this.getAttribute('lang');
				var isLangFound = langAttr.indexOf(v);
				/* shows the elements that contain the relevant language: */
				
				if(isLangFound===-1)
					return false;
				
				return true;
			}
		).show(); 
    });
});
    ]]>
    </script>
    
    <script src="dynamic_URLs.js" type="text/javascript">
	</script>
    <link rel="stylesheet" type="text/css" href="main.css">
    </link>
    </head>
    
    <body onload="onLoadFunction()">
    
    <!-- start .container  -->
    <div class="container"> 
      
      <!-- start .header -->
      <div class="header"> <a href="#" id="home_url"><img class="logo"/></a> <span class="header_menu">
        <label for="language">Lang:</label>
        <select name="language" id="language">
        </select>
         &nbsp; 
        <a href="#" id="xml_url" class="htmlTransl" target="_blank">XML</a> &nbsp; <a href="#" id="java_url" class="htmlTransl">Java</a> &nbsp; <a href="#" id="html_url" class="htmlTransl">HTML</a> &nbsp;</span> 
        <!-- end .header --> 
      </div>
      
      <!-- start .content  -->
      <div class="content"> 
      	<p align="center"> 
      		<span class="interfaceTitle">Error: Java translation not implemented for Allseen</span> 
      	</p>
      <!-- end .content  --> 
      </div>
      <div class="footer">
        <p></p>
        <!-- end .footer --> 
      </div>
      
      <!-- end .container  --> 
    </div>
    </body>
    </html>
  </xsl:template>   
</xsl:stylesheet>