package org.opendof.tools.repository.interfaces.cli;

import org.apache.commons.cli.CommandLine;
import org.opendof.tools.repository.interfaces.cli.util.CliBase;
import org.opendof.tools.repository.interfaces.cli.util.CliCommand;

@SuppressWarnings("javadoc")
public class SwitchOnlyManage extends CliBase
{
    private final CliCommand command;
    
    public SwitchOnlyManage(String[] args)
    {
        super(args, "CONFIG", true, false, DefaultMaxHelpWidth);
        addCommand(new SwitchOnlyCommand(this, null));
        command = validateCommands();
    }
    
    @Override
    public void run()
    {
        CommandLine commandLine =  command.getCommandLine();
        String configpath = System.getProperty("CONFIG");
        configpath = commandLine.getOptionValue(CliBase.ConfigurationPathShortCl);
        
        System.setProperty("CONFIG", configpath);
        try
        {
            log.debug(getClass().getSimpleName() + " exiting OK");
            close(0);
        } catch (Throwable t)
        {
            log.error("failed: ", t);
            close(ApplicationError);
        }
    }

    @Override
    public void close(int ccode)
    {
        super.close(ccode);
    }

    public static void main(String args[])
    {
        new SwitchOnlyManage(args).start();
    }
}