package org.opendof.tools.repository.interfaces.cli.cmds.group;

import org.opendof.tools.repository.interfaces.cli.util.CliBase;
import org.opendof.tools.repository.interfaces.cli.util.CliCommand;

@SuppressWarnings("javadoc")
public class GroupCommand extends CliCommand
{
    // CliBase declares the following shorts. Best not to override them here.
    // 'h',"help"
    // 'c', "config-path"
    // 'v', "version"
    // 'l', "log-path"

    // c, h, l, v used

    public GroupCommand(CliBase cliBase, String commandName)
    {
        super(cliBase, commandName);
    }

    public GroupCommand(CliBase cliBase, CliCommand previousCommand, String commandName)
    {
        super(cliBase, previousCommand, commandName);
    }

    @Override
    protected void cliSetup()
    {
        cliBase.cliReservedSetup(options, cliBase.isLogToFile(), cliBase.isConfigSwitch());
    }

    @Override
    protected void customInit()
    {
    }

    public enum Command
    {
        Add("add"), Delete("delete"), Update("update"), List("list");

        Command(String command)
        {
            this.command = command;
        }

        public static Command getCommand(String arg)
        {
            if (arg.equals(Add.command))
                return Add;
            if (arg.equals(Update.command))
                return Update;
            if (arg.equals(Delete.command))
                return Delete;
            if (arg.equals(List.command))
                return List;
            return null;
        }

        public String command;
    }
}