package org.opendof.tools.repository.interfaces.cli.cmds.group;

import org.apache.commons.cli.Option;
import org.opendof.tools.repository.interfaces.cli.util.CliBase;
import org.opendof.tools.repository.interfaces.cli.util.CliCommand;
import org.opendof.tools.repository.interfaces.cli.util.StrH;

@SuppressWarnings("javadoc")
public class ListGroupCommand extends GroupCommand
{
    // c, h, l, v used
    
    public static final String GroupShortCl = "g";
    public static final String GroupLongCl = "group";

    private volatile ListCmdData listCmdData;

    public ListGroupCommand(CliBase cliBase, CliCommand previousCommand, String commandName)
    {
        super(cliBase, previousCommand, commandName);
    }

    public ListCmdData getListCmdData()
    {
        return listCmdData;
    }
    
    @Override
    protected void cliSetup()
    {
        super.cliSetup();
        //@formatter:off
        options.addOption(
            Option.builder(GroupShortCl)
                .desc("Group where <arg> is the name of the group.  If given the members of the group are returned, otherwise a list of existing groups are returned. Optional.")
                .longOpt(GroupLongCl)
                .hasArg()
                .build());
        //@formatter:on
    }
    
    @Override
    protected void customInit()
    {
        String group = null;
        
        StringBuilder initsb = cliBase.getInitsb();
        if (commandline.hasOption(GroupShortCl))
        {
            group = commandline.getOptionValue(GroupShortCl);
            StrH.ttl(initsb, 1, "--", GroupLongCl, " = ", group);
        }
        listCmdData = new ListCmdData(group);
    }
    
    public class ListCmdData
    {
        public final String group;
        
        public ListCmdData(String group)
        {
            this.group = group;
        }
    }
}