package org.opendof.tools.repository.interfaces.cli.cmds.permission;

import org.opendof.tools.repository.interfaces.cli.util.CliBase;
import org.opendof.tools.repository.interfaces.cli.util.CliCommand;

public class PermissionCommand extends CliCommand {
    // CliBase declares the following shorts. Best not to override them here.
    // 'h',"help"
    // 'c', "config-path"
    // 'v', "version"
    // 'l', "log-path"

    public PermissionCommand(CliBase cliBase, String commandName)
    {
        super(cliBase, commandName);
    }

    public PermissionCommand(CliBase cliBase, CliCommand previousCommand, String commandName)
    {
        super(cliBase, previousCommand, commandName);
        previousCommand = null;
    }

    @Override
    protected void cliSetup()
    {
        cliBase.cliReservedSetup(options, cliBase.isLogToFile(), cliBase.isConfigSwitch());
    }

    @Override
    protected void customInit()
    {
    }

    public enum Command
    {
        Grant("grant"), Revoke("revoke"), List("list"), Get("get");

        Command(String command)
        {
            this.command = command;
        }

        public static Command getCommand(String arg)
        {
            if(arg.equals(Get.command))
                return Get;
            if(arg.equals(Revoke.command))
                return Revoke;
            if(arg.equals(List.command))
                return List;
            if(arg.equals(Get.command))
                return Get;
            return null;
        }
        public String command;
    }

}
