package org.opendof.tools.repository.interfaces.cli.cmds.submitter;

import org.apache.commons.cli.CommandLine;
import org.apache.commons.cli.Option;
import org.opendof.tools.repository.interfaces.cli.util.CliBase;
import org.opendof.tools.repository.interfaces.cli.util.CliCommand;
import org.opendof.tools.repository.interfaces.cli.util.StrH;

@SuppressWarnings("javadoc")
public class DeleteSubmitterCommand extends SubmitterCommand
{
    // c, d, e, h, l, n, v used
    
    public static final String EmailShortCl = "e";
    public static final String EmailLongCl = "email";

    private volatile DeleteCmdData deleteCmdData;
    
    public DeleteSubmitterCommand(CliBase cliBase, CliCommand previousCommand, String commandName)
    {
        super(cliBase, previousCommand, commandName);
    }

    public DeleteCmdData getDeleteCmdData()
    {
        return deleteCmdData;
        
    }
    
    @Override
    protected void cliSetup()
    {
        super.cliSetup();
        //@formatter:off
        options.addOption(
            Option.builder(EmailShortCl)
                .desc("Submitter's email where <arg> is the email address.  Required")
                .longOpt(EmailLongCl)
                .hasArg()
                .required()
                .build());
        //@formatter:on
    }
    
    @Override
    protected void customInit()
    {
        super.customInit();
        
        String email = null;
        
        StringBuilder initsb = cliBase.getInitsb();
        if (commandline.hasOption(EmailShortCl))
        {
            email = commandline.getOptionValue(EmailShortCl);
            StrH.ttl(initsb, 1, "--", EmailLongCl, " = ", email);
        }
        deleteCmdData = new DeleteCmdData(email);
        String msg = deleteCmdData.validate(commandline);
        if(msg != null)
            help(CliBase.InvalidCommand, msg);
    }

    public class DeleteCmdData
    {
        public final String email;
        
        public DeleteCmdData(String email)
        {
            this.email = email;
        }
        
        @SuppressWarnings("unused")
        public String validate(CommandLine commandline)
        {
            return null;
        }
    }

}