package org.opendof.tools.repository.interfaces.cli.cmds.subrepo;

import org.opendof.tools.repository.interfaces.cli.util.CliBase;
import org.opendof.tools.repository.interfaces.cli.util.CliCommand;

@SuppressWarnings("javadoc")
public class SubRepoCommand extends CliCommand
{
    // c, h, l, v used
    
    public static final String PreAllocateShortCl = "a";
    public static final String PreAllocateLongCl = "preallocate";
    public static final String PostAllocateShortCl = "p";
    public static final String PostAllocateLongCl = "postallocate";
    public static final String SubRepoShortCl = "s";
    public static final String SubRepoLongCl = "subrepo";
    
    public static final String EmailShortCl = "e";
    public static final String EmailLongCl = "email";
    public static final String SubmitterShortCl = "u";
    public static final String SubmitterLongCl = "submitter";
    
    public SubRepoCommand(CliBase cliBase, String commandName)
    {
        super(cliBase, commandName);
    }

    public SubRepoCommand(CliBase cliBase, CliCommand previousCommand, String commandName)
    {
        super(cliBase, previousCommand, commandName);
    }

    @Override
    protected void cliSetup()
    {
        cliBase.cliReservedSetup(options, cliBase.isLogToFile(), cliBase.isConfigSwitch());
    }
    
    @Override
    protected void customInit()
    {
    }
    
    public enum Command
    {
        Add("add"), Delete("delete"), Update("update"), List("list");
        
        Command(String command)
        {
            this.command = command;
        }
        
        public static Command getCommand(String arg)
        {
            if(arg.equals(Add.command))
                return Add;
            if(arg.equals(Update.command))
                return Update;
            if(arg.equals(Delete.command))
                return Delete;
            if(arg.equals(List.command))
                return List;
            return null;
        }
        public String command;
    }
}