package org.opendof.tools.repository.interfaces.da;

import java.io.Serializable;
import org.opendof.tools.repository.interfaces.da.SubRepositoryNode.TabToLevel;

public class SubmitterPermissions implements Serializable{

    private static final long serialVersionUID = 5773906749736040934L;

    public final SubmitterData submitter;
    public final PermissionLevel permission;

    public SubmitterPermissions(SubmitterData submitter, PermissionLevel permission)
    {
        this.submitter = submitter;
        this.permission = permission;
    }

    @Override
    public String toString()
    {
        return toString(new TabToLevel()).toString();
    }

    public SubRepositoryNode.TabToLevel toString(TabToLevel format)
    {
        format.ttl("submitter: ", submitter);
        format.ttl("permission: ", permission);
        return format;
    }

    public enum PermissionLevel {
        READ(0),WRITE(1);

        private final int value;

        PermissionLevel(int value){
            this.value = value;
        }

        public int getValue() {
            return value;
        }
        public static PermissionLevel getPermissionLevel(Integer val){
            if(val == null || (val != READ.getValue() && val != WRITE.getValue())){
                return null;
            }
            return val == READ.getValue() ? READ : WRITE;
        }
    }
}
