package org.opendof.tools.repository.interfaces.mysql.data;

import org.opendof.tools.repository.interfaces.da.SubmitterPermissions;
import org.opendof.tools.repository.interfaces.mysql.InterfacePermissionJdbc;
import org.opendof.tools.repository.interfaces.mysql.SubmitterJdbc;

import java.math.BigInteger;
import java.sql.ResultSet;
import java.sql.SQLException;
import java.sql.Timestamp;
import java.util.Date;

public class SubmitterPermissionRow extends SubmitterPermissions {

    private static final long serialVersionUID = 3157069110565575726L;

    public SubmitterPermissionRow(ResultSet rs) throws SQLException
    {
        //@formatter:off
        super(
                new SubmitterRow(rs),
                getPermLevel(rs.getInt(InterfacePermissionJdbc.ColPermissionName))
        );
        //@formatter:on
    }

    public SubmitterPermissionRow(Object[] columns)
    {
        //@formatter:off
        super(
                new SubmitterRow(columns),
                getPermLevel((Integer)columns[InterfacePermissionJdbc.ColPermissionNameIdx-1]));
        //@formatter:on
    }

    private static SubmitterPermissions.PermissionLevel getPermLevel(int level){
        return level == PermissionLevel.WRITE.getValue() ? PermissionLevel.WRITE : PermissionLevel.READ;
    }
}
