/*
**  Copyright (c) 2010-2015, Panasonic Corporation.
**
**  Permission to use, copy, modify, and/or distribute this software for any
**  purpose with or without fee is hereby granted, provided that the above
**  copyright notice and this permission notice appear in all copies.
**
**  THE SOFTWARE IS PROVIDED "AS IS" AND THE AUTHOR DISCLAIMS ALL WARRANTIES
**  WITH REGARD TO THIS SOFTWARE INCLUDING ALL IMPLIED WARRANTIES OF
**  MERCHANTABILITY AND FITNESS. IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR
**  ANY SPECIAL, DIRECT, INDIRECT, OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES
**  WHATSOEVER RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN
**  ACTION OF CONTRACT, NEGLIGENCE OR OTHER TORTIOUS ACTION, ARISING OUT OF
**  OR IN CONNECTION WITH THE USE OR PERFORMANCE OF THIS SOFTWARE.
*/
package org.opendof.tools.repository.interfaces.opendof.saxParser.typedef.custom;

import org.opendof.tools.repository.interfaces.opendof.saxParser.MetadataElements;
import org.opendof.tools.repository.interfaces.opendof.saxParser.typedef.DofTypeBase;

/**
 * DofIid Element SAX handler.  
 */
public class DofIidElement extends DofTypeBase
{
    private static String IidElement = "iid";

    /**
     * DofIidElement constructor
     * @param childComplete the child completion callback to my parent.  Must not be null.
     */
    public DofIidElement(ChildComplete childComplete)
    {
        super(childComplete);
    }

    public DofIidElement(int itemId, MetadataElements metadata)
    {
        super(itemId, metadata);
    }

    @Override
    public StringBuilder export(StringBuilder sb, int level)
    {
        element(sb, IidElement, TypeIdAttr, ""+typeId, null, metadata == null, level);
        return exportNames(sb, IidElement, metadata, true, level);
    }
}
