<?xml version="1.0" encoding="utf-8"?>

<!DOCTYPE xsl:stylesheet  [
	<!ENTITY nbsp   "&#160;">
	<!ENTITY copy   "&#169;">
	<!ENTITY reg    "&#174;">
	<!ENTITY trade  "&#8482;">
	<!ENTITY mdash  "&#8212;">
	<!ENTITY ldquo  "&#8220;">
	<!ENTITY rdquo  "&#8221;"> 
	<!ENTITY pound  "&#163;">
	<!ENTITY yen    "&#165;">
	<!ENTITY euro   "&#8364;">
    <!ENTITY emsp   "&#8195;">
]>

<xsl:stylesheet version="1.0"
	xmlns:xsl="http://www.w3.org/1999/XSL/Transform"
	xmlns:md="http://opendof.org/schema/interface-repository-meta"
    xmlns:cr="http://opendof.org/schema/interface-repository" 
    xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance">
  <xsl:output 
  	method="html" 
    encoding="utf-8" 
    doctype-public="-//W3C//DTD XHTML 1.0 Transitional//EN" 
    doctype-system="http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd"/>
  <xsl:template match="/">
    <!-- html xmlns="http://www.w3.org/1999/xhtml">
    <head>
    <meta http-equiv="Content-Type" content="text/html; charset=utf-8" />
    <title>
    	<xsl:choose>
		    <xsl:when test="/cr:interface/md:code-name">
		    	<xsl:value-of select="/cr:interface/md:code-name"/>
		    </xsl:when>
		    <xsl:otherwise>
            	<xsl:value-of select="/cr:interface/@iid"/>
            </xsl:otherwise>
    	</xsl:choose>
    	- Overview
    </title>
	<link rel="icon" href="images/favicon.ico" type="image/x-icon" />
	<link rel="shortcut icon" href="images/favicon.ico" type="image/x-icon" /> 	
    <script src="https://ajax.googleapis.com/ajax/libs/jquery/1.11.3/jquery.min.js"></script>
    <script>
    <![CDATA[
$(document).ready(function() {
    /* get all lang attribute values and remove duplicates */
    var langValues = [];
    $("[lang]").each(function() {
    	langValues.push($(this).attr("lang"))
    });
   
    /* this works in mozilla and IE when removing duplicates in array */
	var uniqueLangValues = [];
	$.each(langValues, function(i, el){
	    if($.inArray(el, uniqueLangValues) === -1) uniqueLangValues.push(el);
	});   
	    
    /* build actual dropdown menu */
    var selectedAttr = "";
    $.each(uniqueLangValues, function(index, value) {
        if(value === "en")
    		selectedAttr = " selected='selected'";
        else
            selectedAttr = "";

    	$("#language").append("<option value=" + value + selectedAttr + ">" + value + "</option>");
    });
    
	/* expand/collapse */
	$('.panel-36').hide();
	$('.toggler-36').click(function()
	{
		$(this).next('.panel-36').slideToggle(600);
	});
	
	/* show English only as default */
	$("[lang]").hide();	
	$("[lang='en']").show();
	
	/* hide-show by lang attribute from selection */
	$('#language').change(
    function()
    {
		/* storing the language chosen in the select element */
		var v = this.value;
		/* iterates over all elements with lang attribute, and hides them,
		   then filters the matched elements to see which elements
		   contain the relevant language in the 'lang' attribute: */
		$("[lang]").hide().filter(
			function()
			{
				var langAttr = this.getAttribute('lang');
				var isLangFound = langAttr.indexOf(v);
				/* shows the elements that contain the relevant language: */
				
				if(isLangFound===-1)
					return false;
				
				return true;
			}
		).show(); 
    });
});
    ]]>
    </script>    
    
    <script src="dynamic_URLs.js" type="text/javascript">
	</script>
    <link rel="stylesheet" type="text/css" href="main.css">
    </link>
    </head-->
    
    <!--body onload="onLoadFunction()"-->
    
    <!-- start .container  -->
    <!-- >div class="container"--> 
      
      <!-- start .header -->
      <!--div class="header"> 
      	<a href="#" id="home_url"><img class="logo"/></a> <span class="header_menu">
        <label for="language">Lang:</label>
        <select name="language" id="language">
        </select>
         &nbsp; 
        <a href="#" id="xml_url" class="htmlTransl" target="_blank">XML</a> &nbsp; <a href="#" id="java_url" class="htmlTransl">Java</a> &nbsp; <a href="#" id="html_url" class="htmlTransl">HTML</a> &nbsp;</span> 
      </div-->
      
      <!-- start .content  -->
      <div class="content"> 
        
        <!-- IID INFO --> 
        <!-- DISPLAY-NAME -->
        <p> <span class="interfaceTitle">
          <xsl:apply-templates select="/cr:interface/md:display-name"/>
          
          </span> </p>
        <!-- IID -->
        <p> IID: <xsl:value-of select="/cr:interface/@iid"/></p>
        <xsl:apply-templates select="/cr:interface/md:description"/>
        
        <p></p>
        
        <!-- TYPE DEFINITIONS -->
        <xsl:if test="/cr:interface/cr:typedefs/*">
          <h3 class="toggler-36 sliderHeader">> Type Definitions</h3>
          <div class="panel-36 expandedContent"> 
            <!-- STRING -->
            <xsl:apply-templates select="/cr:interface/cr:typedefs/cr:string"/>   
            
            <!-- BOOLEAN -->
            <xsl:apply-templates select="/cr:interface/cr:typedefs/cr:boolean"/>     
            
            <!-- UINT8 -->
            <xsl:apply-templates select="/cr:interface/cr:typedefs/cr:uint8"/>
              
            <!-- UINT16 -->
            <xsl:apply-templates select="/cr:interface/cr:typedefs/cr:uint16"/>
            
            <!-- UINT32 -->
            <xsl:apply-templates select="/cr:interface/cr:typedefs/cr:uint32"/>
            
            <!-- UINT64 -->
            <xsl:apply-templates select="/cr:interface/cr:typedefs/cr:uint64"/>
            
            <!-- INT8 -->
            <xsl:apply-templates select="/cr:interface/cr:typedefs/cr:int8"/>
            
            <!-- INT16 -->
            <xsl:apply-templates select="/cr:interface/cr:typedefs/cr:int16"/>
            
            <!-- INT32 -->
            <xsl:apply-templates select="/cr:interface/cr:typedefs/cr:int32"/>
            
            <!-- INT64 -->
            <xsl:apply-templates select="/cr:interface/cr:typedefs/cr:int64"/>
            
            <!-- FLOAT32  -->
            <xsl:apply-templates select="/cr:interface/cr:typedefs/cr:float32"/>
            
            <!-- FLOAT64 -->
            <xsl:apply-templates select="/cr:interface/cr:typedefs/cr:float64"/>
            
            <!-- DATETIME -->
            <xsl:apply-templates select="/cr:interface/cr:typedefs/cr:datetime"/>
            
            <!-- ARRAY -->
            <xsl:apply-templates select="/cr:interface/cr:typedefs/cr:array"/>
            
            <!-- REFERENCE -->
            <xsl:apply-templates select="/cr:interface/cr:typedefs/cr:reference"/>
            
            <!-- STRUCTURE -->
            <xsl:apply-templates select="/cr:interface/cr:typedefs/cr:structure"/>
            
            <!-- UUID -->
            <xsl:apply-templates select="/cr:interface/cr:typedefs/cr:uuid"/>
            
            <!-- BLOB -->
            <xsl:apply-templates select="/cr:interface/cr:typedefs/cr:blob"/>
            
            <!-- NULLABLE -->
            <xsl:apply-templates select="/cr:interface/cr:typedefs/cr:nullable"/>
            
            <!-- OID -->
            <xsl:apply-templates select="/cr:interface/cr:typedefs/cr:oid"/>
            
            <!-- IID -->
            <xsl:apply-templates select="/cr:interface/cr:typedefs/cr:iid"/>
            
          </div>
        </xsl:if>
        
        <!-- PROPERTIES -->
        <xsl:if test="/cr:interface/cr:properties/*">
          <h3 class="toggler-36 sliderHeader">> Properties</h3>
          <div class="panel-36 expandedContent">
            <xsl:apply-templates select="/cr:interface/cr:properties"/>            
          </div>
        </xsl:if>
        
        <!-- METHODS -->
        <xsl:if test="/cr:interface/cr:methods/*">
          <h3 class="toggler-36 sliderHeader">> Methods</h3>
          <div class="panel-36 expandedContent">
            <xsl:apply-templates select="/cr:interface/cr:methods"/>            
          </div>
        </xsl:if>
        
        <!-- EVENTS -->
        <xsl:if test="/cr:interface/cr:events/*">
          <h3 class="toggler-36 sliderHeader">> Events</h3>
          <div class="panel-36 expandedContent">
            <xsl:apply-templates select="/cr:interface/cr:events"/>            
          </div>
        </xsl:if>
        
        <!-- EXCEPTIONS -->
        <xsl:if test="/cr:interface/cr:exceptions/*">
          <h3 class="toggler-36 sliderHeader">> Exceptions</h3>
          <div class="panel-36 expandedContent">
            <xsl:apply-templates select="/cr:interface/cr:exceptions"/>            
          </div>
        </xsl:if>
        
        <br />
        <br />
        
        <!-- end .content  --> 
      </div>
      <!--div class="footer">
      	<p></p>
      </div-->
      
      <!-- end .container  --> 
    <!-- /div>
    </body>
    </html-->
  </xsl:template>
  
  <!-- SUB TEMPLATE DEFINITIONS -->
  <!-- TYPE DEFINITIONS -->
  
  <!-- STRING -->
  <xsl:template match="cr:string">
    <span class="expandedItem">
    <!-- DISPLAY-NAME -->
    <span class="name"><xsl:apply-templates select="md:display-name"/></span>
    <!-- DISPLAY TYPE ID -->
    <span class="id">Type ID:&nbsp;<xsl:value-of select="@type-id"/></span>
    <p class="clearFloat"></p>
    <!-- KNOWN-VALUES -->
    <table class="knownValue">
    	<xsl:apply-templates select="md:known-value"/>
    </table>
    <!-- DESCRIPTION -->
    <xsl:apply-templates select="md:description"/><br />
    <!-- ENCODING -->
    <xsl:if test="@encoding">
    	<br />Encoding:&nbsp;<xsl:value-of select="@encoding"/>
    </xsl:if>
    <!-- LENGTH -->
    <xsl:if test="@length">
    	<br />Length:&nbsp;<xsl:value-of select="@length"/>
    </xsl:if>
    <!-- TYPE -->
    <br />Type:&nbsp;<xsl:value-of select="local-name()"/><br />
    </span>
  </xsl:template>
  
  <!-- DATETIME, UUID, BOOLEAN, OID, IID -->
  <xsl:template match="cr:datetime  | cr:uuid  | cr:boolean | cr:oid  | cr:iid">
    <span class="expandedItem">
    <!-- DISPLAY-NAME -->
    <span class="name"><xsl:apply-templates select="md:display-name"/></span>
    <!-- DISPLAY TYPE ID -->
    <span class="id">Type ID:&nbsp;<xsl:value-of select="@type-id"/></span>
    <p class="clearFloat"></p>
    <!-- KNOWN-VALUES -->
    <table class="knownValue">
    	<xsl:apply-templates select="md:known-value"/>
    </table>
    <!-- DESCRIPTION -->
    <xsl:apply-templates select="md:description"/><br />
    <!-- TYPE -->
    <br />Type:&nbsp;<xsl:value-of select="local-name()"/><br />
    </span>
  </xsl:template>
  
  <!-- BLOB -->
  <xsl:template match="cr:blob">
    <span class="expandedItem">
    <!-- DISPLAY-NAME -->
    <span class="name"><xsl:apply-templates select="md:display-name"/></span>
    <!-- DISPLAY TYPE ID -->
    <span class="id">Type ID:&nbsp;<xsl:value-of select="@type-id"/></span>
    <p class="clearFloat"></p>
    <!-- KNOWN-VALUES -->
    <table class="knownValue">
    	<xsl:apply-templates select="md:known-value"/>
    </table>
    <!-- DESCRIPTION -->
    <xsl:apply-templates select="md:description"/><br />
    <!-- MIN-LENGTH -->
    <xsl:if test="@min-length">
      <br />Min Length:&nbsp;<xsl:value-of select="@min-length"/>
    </xsl:if>
    <!-- LENGTH -->
    <xsl:if test="@length">
      <br />Length:&nbsp;<xsl:value-of select="@length"/>
    </xsl:if>
    <!-- TYPE -->
    <br />Type:&nbsp;<xsl:value-of select="local-name()"/><br />
    </span>
  </xsl:template>
  
  <!-- NUMERICALS -->
  <xsl:template match="cr:uint8 | cr:uint16 | cr:uint32 | cr:uint64 | cr:int8 | cr:int16 | cr:int32 | cr:int64 | cr:float32 | cr:float64">
    <span class="expandedItem">
    <!-- DISPLAY-NAME -->
    <span class="name"><xsl:apply-templates select="md:display-name"/></span>
    <!-- DISPLAY TYPE ID -->
    <span class="id">Type ID:&nbsp;<xsl:value-of select="@type-id"/></span>
    <p class="clearFloat"></p>
    <!-- KNOWN-VALUES -->
    <table class="knownValue">
    	<xsl:apply-templates select="md:known-value"/>
    </table>
    <!-- DESCRIPTION -->
    <xsl:apply-templates select="md:description"/><br />
    <!-- MAX -->
    <br />MAX:&nbsp;<xsl:value-of select="@max"/>
    <!-- MIN -->
    <br />MIN:&nbsp;<xsl:value-of select="@min"/>
    <!-- UNIT -->
    <br />Unit:&nbsp;<xsl:value-of select="cr:unit"/>
    <!-- TYPE -->
    <br />Type:&nbsp;<xsl:value-of select="local-name()"/><br />
    </span>
  </xsl:template>
  
  <!-- ARRAY -->
  <xsl:template match="cr:array">
    <span class="expandedItem">
    <!-- DISPLAY-NAME -->
    <span class="name"><xsl:apply-templates select="md:display-name"/></span>
    <!-- DISPLAY TYPE ID -->
    <span class="id">Type ID:&nbsp;<xsl:value-of select="@type-id"/></span>
    <p class="clearFloat"></p>
    <!-- KNOWN-VALUES -->
    <table class="knownValue">
    	<xsl:apply-templates select="md:known-value"/>
    </table>
    <!-- DESCRIPTION -->
    <xsl:apply-templates select="md:description"/><br />
    <!-- MIN-LENGTH -->
    <xsl:if test="@min-length">
      <br />Min Length:&nbsp;<xsl:value-of select="@min-length"/>
    </xsl:if>
    <!-- LENGTH -->
    <xsl:if test="@length">
      <br />Length:&nbsp;<xsl:value-of select="@length"/>
    </xsl:if>
    <!-- TYPE -->
    <br />Type:&nbsp;<xsl:value-of select="local-name()"/> (
    <xsl:variable name="var_type" select="@type-ref"/>
    <xsl:for-each select="/cr:interface/cr:typedefs/cr:*[@type-id=$var_type]/md:display-name">      
      <span><xsl:attribute name="lang"><xsl:value-of select="@xml:lang"/></xsl:attribute>
      	 <xsl:value-of select="$var_type" /> - <xsl:value-of select="." />
      </span>
    </xsl:for-each> )
    </span>
  </xsl:template>
  
  <!-- REFERENCE, NULLABLE -->
  <xsl:template match="cr:reference | cr:nullable">
    <span class="expandedItem">
    <!-- DISPLAY-NAME -->
    <span class="name"><xsl:apply-templates select="md:display-name"/></span>
    <!-- DISPLAY TYPE ID -->
    <span class="id">Type ID:&nbsp;<xsl:value-of select="@type-id"/></span>
    <p class="clearFloat"></p>
    <!-- KNOWN-VALUES -->
    <table class="knownValue">
    	<xsl:apply-templates select="md:known-value"/>
    </table>
    <!-- DESCRIPTION -->
    <xsl:apply-templates select="md:description"/><br />
    <!-- TYPE -->
    <br />Type:&nbsp;<xsl:value-of select="local-name()"/> (
    <xsl:variable name="var_type" select="@type-ref"/>
    <xsl:for-each select="/cr:interface/cr:typedefs/cr:*[@type-id=$var_type]/md:display-name">
      <span>
      <xsl:attribute name="lang"><xsl:value-of select="@xml:lang"/></xsl:attribute>
      	<xsl:value-of select="." />
      </span>
    </xsl:for-each> )
    </span>
  </xsl:template>
  
  <!-- STRUCT -->
  <xsl:template match="cr:structure">
    <span class="expandedItem">
    <!-- DISPLAY-NAME -->
    <span class="name"><xsl:apply-templates select="md:display-name"/></span>
    <!-- DISPLAY TYPE ID -->
    <span class="id">Type ID:&nbsp;<xsl:value-of select="@type-id"/></span>
    <p class="clearFloat"></p>
    <!-- KNOWN-VALUES -->
    <table class="knownValue">
    	<xsl:apply-templates select="md:known-value"/>
    </table>
    <!-- DESCRIPTION -->
    <xsl:apply-templates select="md:description"/><br />  
    <!-- TYPE AND FIELDS -->
    <br />Type:&nbsp;<xsl:value-of select="local-name()"/> { <xsl:apply-templates select="cr:field"/> }<br />
    </span>
  </xsl:template>
  
  <!-- PROPERTIES -->
  <xsl:template match="cr:property">
    <span class="expandedItem">
    <!-- DISPLAY-NAME -->
    <span class="name"><xsl:apply-templates select="md:display-name"/></span> 
    <!-- DISPLAY Item ID -->
    <span class="id">Item ID:&nbsp;<xsl:value-of select="@item-id"/></span>
    <p class="clearFloat"></p> 
    <!-- KNOWN-VALUES -->
    <table class="knownValue">
    	<xsl:apply-templates select="md:known-value"/>
    </table> 
    <!-- DESCRIPTION -->
    <xsl:apply-templates select="md:description"/><br />
    <!-- READ/WRITE -->
    <br />Read:&nbsp;<xsl:value-of select="@read" />
    <br />Write:&nbsp;<xsl:value-of select="@write" />
    <!-- TYPE -->
    <br />Type:&nbsp;<xsl:value-of select="@type-ref" />&nbsp;-&nbsp;
    <xsl:variable name="var_type" select="@type-ref"/>
    <xsl:for-each select="/cr:interface/cr:typedefs/cr:*[@type-id=$var_type]/md:display-name">
      <span>
      <xsl:attribute name="lang"><xsl:value-of select="@xml:lang"/></xsl:attribute>
      	<xsl:value-of select="." />
      </span>
    </xsl:for-each>
    </span>
  </xsl:template>
  
  <!-- METHODS -->
  <xsl:template match="cr:method">
    <span class="expandedItem">
    <!-- DISPLAY-NAME -->
    <span class="name"><xsl:apply-templates select="md:display-name"/></span>  
    <!-- DISPLAY Item ID -->
    <span class="id">Item ID:&nbsp;<xsl:value-of select="@item-id"/></span>
    <p class="clearFloat"></p>   
    <!-- KNOWN-VALUES -->
    <table class="knownValue">
    	<xsl:apply-templates select="md:known-value"/>
    </table>
    <!-- DESCRIPTION -->
    <br /><xsl:apply-templates select="md:description"/><br />
    <!-- INPUTS -->
    <xsl:if test="cr:inputs">
    <br />Inputs:<br />
      <xsl:apply-templates select="cr:inputs/cr:input"/>
    </xsl:if>
    <!-- OUTPUTS -->
    <xsl:if test="cr:outputs">
    Outputs:<br />
      <xsl:apply-templates select="cr:outputs/cr:output"/>
    </xsl:if>
    </span>
  </xsl:template>
  
  <!-- EVENTS -->
  <xsl:template match="cr:event">
    <span class="expandedItem">
    <!-- DISPLAY-NAME -->
    <span class="name"><xsl:apply-templates select="md:display-name"/></span>   
    <!-- DISPLAY Item ID -->
    <span class="id">Item ID:&nbsp;<xsl:value-of select="@item-id"/></span>
    <p class="clearFloat"></p> 
    <!-- KNOWN-VALUES -->
    <table class="knownValue">
    	<xsl:apply-templates select="md:known-value"/>
    </table> 
    <!-- DESCRIPTION -->
    <br /><xsl:apply-templates select="md:description"/><br />
    <!-- OUTPUTS -->
    <xsl:if test="cr:outputs">
    <br />Outputs:<br />
      <xsl:apply-templates select="cr:outputs/cr:output"/>
    </xsl:if>
    </span>
  </xsl:template>
  
  <!-- EXCEPTIONS -->
  <xsl:template match="cr:exception">
    <span class="expandedItem">
    <!-- DISPLAY-NAME -->
    <span class="name"><xsl:apply-templates select="md:display-name"/></span>  
    <!-- DISPLAY Item ID -->
    <span class="id">Item ID:&nbsp;<xsl:value-of select="@item-id"/></span>
    <p class="clearFloat"></p>  
    <!-- KNOWN-VALUES -->
    <table class="knownValue">
    	<xsl:apply-templates select="md:known-value"/>
    </table> 
    <!-- DESCRIPTION -->
    <br /><xsl:apply-templates select="md:description"/></span>
  </xsl:template>
  
  <!-- HELP SUB TEMPLATES -->
  <!-- DISPLAY-NAME TEMPLATE DEFINITIONS -->
  <xsl:template match="md:display-name">
    <span>
        <xsl:attribute name="lang"><xsl:value-of select="@xml:lang"/></xsl:attribute>
        <xsl:value-of select="."/>
    </span>
  </xsl:template>
  
  <!-- DESCRIPTION TEMPLATE DEFINITIONS -->
  <xsl:template match="md:description">
    <span class="description">
        <xsl:attribute name="lang"><xsl:value-of select="@xml:lang"/></xsl:attribute>
        <xsl:value-of select="." disable-output-escaping="yes"/>
    </span>
  </xsl:template>
  
  <!-- INPUTS, OUTPUTS -->
  <xsl:template match="cr:input | cr:output">
  	<!-- TYPE REF -->
  	&emsp;<xsl:value-of select="@type-ref" />&nbsp;-&nbsp;
    <!-- DISPLAY-NAME -->
    <xsl:if test="md:display-name">
    	<xsl:apply-templates select="md:display-name"/>
    </xsl:if>
    <xsl:if test="not(md:display-name)">
    	<xsl:variable name="var_type" select="@type-ref"/>
        <xsl:for-each select="/cr:interface/cr:typedefs/cr:*[@type-id=$var_type]/md:display-name">
            <span>
                <xsl:attribute name="lang"><xsl:value-of select="@xml:lang"/></xsl:attribute>
                <xsl:value-of select="." />
            </span>
    	</xsl:for-each>
    </xsl:if>
    <!-- DESCRIPTION -->
    <xsl:if test="md:description">
         - <xsl:apply-templates select="md:description"/>
    </xsl:if>
    <xsl:if test="not(md:description)">
         - <xsl:variable name="var_type" select="@type-ref"/>
        <xsl:for-each select="/cr:interface/cr:typedefs/cr:*[@type-id=$var_type]/md:description">
            <span>
                <xsl:attribute name="lang"><xsl:value-of select="@xml:lang"/></xsl:attribute>
                <xsl:value-of select="." />
            </span>
        </xsl:for-each>
    </xsl:if> 
    <br />
  </xsl:template>
  
  <!-- FIELDS -->
  <xsl:template match="cr:field">
    <!-- DISPLAY-NAME -->
    <xsl:if test="md:display-name">
    	<xsl:value-of select="@type-ref" /> - 
        <xsl:apply-templates select="md:display-name"/>
            <xsl:if test="position() != last()">
            	 ,&nbsp;
            </xsl:if> 
    </xsl:if>
  </xsl:template>
  
  <!-- KNOWN-VALUES TABLE ROWS -->
  <xsl:template match="md:known-value">
    <tr>
        <xsl:attribute name="lang"><xsl:value-of select="@xml:lang"/></xsl:attribute>
        <td><xsl:value-of select="@value"/></td>
        <td><xsl:value-of select="." disable-output-escaping="yes"/></td>
    </tr>
  </xsl:template>
</xsl:stylesheet>
