<?xml version="1.0" encoding="utf-8"?>

<!DOCTYPE xsl:stylesheet  [
	<!ENTITY nbsp   "&#160;">
	<!ENTITY copy   "&#169;">
	<!ENTITY reg    "&#174;">
	<!ENTITY trade  "&#8482;">
	<!ENTITY mdash  "&#8212;">
	<!ENTITY ldquo  "&#8220;">
	<!ENTITY rdquo  "&#8221;"> 
	<!ENTITY pound  "&#163;">
	<!ENTITY yen    "&#165;">
	<!ENTITY euro   "&#8364;">
    <!ENTITY emsp   "&#8195;">
]>

<xsl:stylesheet version="1.0"
	xmlns:xsl="http://www.w3.org/1999/XSL/Transform"
	xmlns:md="http://opendof.org/schema/interface-repository-meta"
    xmlns:cr="http://opendof.org/schema/interface-repository" 
    xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance">
  <xsl:output method="html" encoding="utf-8" doctype-public="-//W3C//DTD XHTML 1.0 Transitional//EN" doctype-system="http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd"/>
  <xsl:template match="/">
    <!--html xmlns="http://www.w3.org/1999/xhtml">
    <head>
    <meta http-equiv="Content-Type" content="text/html; charset=utf-8" />
    <title>
    	<xsl:choose>
		    <xsl:when test="/cr:interface/md:code-name">
		    	<xsl:value-of select="/cr:interface/md:code-name"/>
		    </xsl:when>
		    <xsl:otherwise>
            	<xsl:value-of select="/cr:interface/@iid"/>
            </xsl:otherwise>
    	</xsl:choose>
    	- Java Code
    </title>
	<link rel="icon" href="images/favicon.ico" type="image/x-icon" />
	<link rel="shortcut icon" href="images/favicon.ico" type="image/x-icon" /> 	   
    <script src="https://ajax.googleapis.com/ajax/libs/jquery/1.11.3/jquery.min.js"></script>
    <script>
    <![CDATA[
$(document).ready(function() {
    /* get all lang attribute values and remove duplicates */
    var langValues = [];
    $("[lang]").each(function() {
    	langValues.push($(this).attr("lang"))
    });
   
    /* this works in mozilla and IE when removing duplicates in array */
	var uniqueLangValues = [];
	$.each(langValues, function(i, el){
	    if($.inArray(el, uniqueLangValues) === -1) uniqueLangValues.push(el);
	});   
	    
    /* build actual dropdown menu */
    var selectedAttr = "";
    $.each(uniqueLangValues, function(index, value) {
        if(value === "en")
    		selectedAttr = " selected='selected'";
        else
            selectedAttr = "";

    	$("#language").append("<option value=" + value + selectedAttr + ">" + value + "</option>");
    });
    
	/* expand/collapse */
	$('.panel-36').hide();
	$('.toggler-36').click(function()
	{
		$(this).next('.panel-36').slideToggle(600);
	});
	
	/* show English only as default */
	$("[lang]").hide();	
	$("[lang='en']").show();
	
	/* hide-show by lang attribute from selection */
	$('#language').change(
    function()
    {
		/* storing the language chosen in the select element */
		var v = this.value;
		/* iterates over all elements with lang attribute, and hides them,
		   then filters the matched elements to see which elements
		   contain the relevant language in the 'lang' attribute: */
		$("[lang]").hide().filter(
			function()
			{
				var langAttr = this.getAttribute('lang');
				var isLangFound = langAttr.indexOf(v);
				/* shows the elements that contain the relevant language: */
				
				if(isLangFound===-1)
					return false;
				
				return true;
			}
		).show(); 
    });
});
    ]]>
    </script>
    
    <script src="dynamic_URLs.js" type="text/javascript">
	</script>
    <link rel="stylesheet" type="text/css" href="main.css">
    </link>
    </head>
    
    <body onload="onLoadFunction()"-->
    
    <!-- start .container  -->
    <!--div class="container"--> 
      
      <!-- start .header -->
      <!--div class="header"> <a href="#" id="home_url"><img class="logo"/></a> <span class="header_menu">
        <label for="language">Lang:</label>
        <select name="language" id="language">
        </select>
         &nbsp; 
        <a href="#" id="xml_url" class="htmlTransl" target="_blank">XML</a> &nbsp; <a href="#" id="java_url" class="htmlTransl">Java</a> &nbsp; <a href="#" id="html_url" class="htmlTransl">HTML</a> &nbsp;</span> 
         
      </div-->
      
      <!-- start .content  -->
      <div class="content"> 
        <!-- code comment -->
        <div class="code_comment">
          /** <br /> 
          <!-- IID INFO --> 
          <!-- Interface name -->
          &nbsp;* <![CDATA[<b>]]>
          <xsl:for-each select="/cr:interface/md:display-name">
            <span>
			    <xsl:attribute name="lang"><xsl:value-of select="@xml:lang"/></xsl:attribute>
			    <xsl:value-of select="." />
			</span>
          </xsl:for-each>
          <![CDATA[</b><br />]]>
          <br />
          <!-- Interface description -->
          &nbsp;* <xsl:for-each select="/cr:interface/md:description">
            <span>
			    <xsl:attribute name="lang"><xsl:value-of select="@xml:lang"/></xsl:attribute>
			    <xsl:value-of select="." />
			</span>
            <![CDATA[<br /><br />]]>
          </xsl:for-each>
          <br />
          &nbsp;* <br />
          &nbsp;* IID: <xsl:value-of select="/cr:interface/@iid"/>
          <![CDATA[<br />]]>
          <br />
          &nbsp;* <br />
          <!-- PROPERTIES -->
          <xsl:if test="/cr:interface/cr:properties">
            &nbsp;* <![CDATA[<b>]]>
            Properties
            <![CDATA[</b><br />]]>
            <br />
            <!-- KNOWN-VALUES -->  
            <xsl:if test="md:known-value">         
	            <![CDATA[* <table>]]>
					<xsl:apply-templates select="md:known-value"/>
				<![CDATA[</table>]]>
	            <br />
            </xsl:if>
            <xsl:for-each select="/cr:interface/cr:properties/cr:property">
              <!-- DISPLAY-NAME -->
              <xsl:for-each select="md:display-name">
                <span>
			      <xsl:attribute name="lang"><xsl:value-of select="@xml:lang"/></xsl:attribute>
			      	&nbsp;* <xsl:value-of select="." />
			     </span>
              </xsl:for-each>
              <br />
              
              <!-- DESCRIPTION -->
              <xsl:for-each select="md:description">
                <span>
				    <xsl:attribute name="lang"><xsl:value-of select="@xml:lang"/></xsl:attribute>
				    &nbsp;* <xsl:value-of select="." />
				</span>
                  <![CDATA[<br />]]>
                  <br />
              </xsl:for-each>              
              &nbsp;* <![CDATA[<ul>]]>
              <br/>
              <!-- READ -->
              &nbsp;* <![CDATA[<li>]]>
              Read: <xsl:value-of select="@read"/>
              <![CDATA[</li>]]>
              <br />
              <!-- WRITE -->
              &nbsp;* <![CDATA[<li>]]>
              Write: <xsl:value-of select="@write"/>
              <![CDATA[</li>]]>
              <br />
              &nbsp;* <![CDATA[</ul>]]>
              <br />
            </xsl:for-each>
          </xsl:if>
          &nbsp;* <br />
          
          <!-- METHODS -->
         <xsl:if test="/cr:interface/cr:methods">
            &nbsp;* <![CDATA[<b>]]>
             Methods
            <![CDATA[</b><br />]]>
            <br />
            <!-- KNOWN-VALUES -->  
            <xsl:if test="md:known-value">            
	            <![CDATA[* <table>]]>
					<xsl:apply-templates select="md:known-value"/>
				<![CDATA[</table>]]>
	            <br />
            </xsl:if>
            <xsl:for-each select="/cr:interface/cr:methods/cr:method">
              <!-- DISPLAY-NAME -->
              <xsl:for-each select="md:display-name">
                <span>
				    <xsl:attribute name="lang"><xsl:value-of select="@xml:lang"/></xsl:attribute>
				    &nbsp;* <![CDATA[<i>]]><xsl:value-of select="." /><![CDATA[</i><br />]]>
				</span>
                <br />
              </xsl:for-each>              
              <!-- DESCRIPTION -->
              <xsl:for-each select="md:description">
                <span>
				    <xsl:attribute name="lang"><xsl:value-of select="@xml:lang"/></xsl:attribute>
				    &nbsp;* <xsl:value-of select="." />
				</span>
                  <![CDATA[<br />]]>
                  <br />
              </xsl:for-each>              
              <!-- INPUTS -->
              <xsl:if test="cr:inputs">
                <xsl:apply-templates select="cr:inputs"/>
              </xsl:if>              
              <!-- OUTPUTS -->
              <xsl:if test="cr:outputs">
                <xsl:apply-templates select="cr:outputs"/>
              </xsl:if>
              &nbsp;* <br />
            </xsl:for-each>
          </xsl:if>
          &nbsp;* <br />
          
          <!-- EVENTS -->
          <xsl:if test="/cr:interface/cr:events">
            &nbsp;* <![CDATA[<b>]]>
            Events
            <![CDATA[</b><br />]]>
            <br />
            <!-- KNOWN-VALUES -->  
            <xsl:if test="md:known-value">            
	            <![CDATA[* <table>]]>
					<xsl:apply-templates select="md:known-value"/>
				<![CDATA[</table>]]>
	            <br />
            </xsl:if>
            <xsl:for-each select="/cr:interface/cr:events/cr:event">
              <!-- DISPLAY-NAME -->
              <xsl:for-each select="md:display-name">
                <span>
					<xsl:attribute name="lang"><xsl:value-of select="@xml:lang"/></xsl:attribute>
					&nbsp;* <![CDATA[<i>]]><xsl:value-of select="." /><![CDATA[</i><br />]]>
				</span>
                <br />
              </xsl:for-each>              
              <!-- DESCRIPTION -->
              <xsl:for-each select="md:description">
                <span>
					<xsl:attribute name="lang"><xsl:value-of select="@xml:lang"/></xsl:attribute>
					&nbsp;* <xsl:value-of select="." />
				</span>
                <br />
              </xsl:for-each>
              <!-- OUTPUTS -->
              <xsl:if test="cr:outputs">
                <xsl:apply-templates select="cr:outputs"/>
              </xsl:if>
              &nbsp;* <br  />
            </xsl:for-each>
          </xsl:if>
          
          <!-- EXCEPTIONS -->
          <xsl:if test="/cr:interface/cr:exceptions">
            &nbsp;* <![CDATA[<b>]]>
            Exceptions
            <![CDATA[</b><br />]]>
            <br />
            <!-- KNOWN-VALUES -->  
            <xsl:if test="md:known-value">            
	            <![CDATA[* <table>]]>
					<xsl:apply-templates select="md:known-value"/>
				<![CDATA[</table>]]>
	            <br />
            </xsl:if>
            <xsl:for-each select="/cr:interface/cr:exceptions/cr:exception">
              <!-- DISPLAY-NAME -->
              <xsl:for-each select="md:display-name">
                <span>
					<xsl:attribute name="lang"><xsl:value-of select="@xml:lang"/></xsl:attribute>
					&nbsp;* <![CDATA[<i>]]><xsl:value-of select="." /><![CDATA[</i><br />]]>
				</span>
                <br />
              </xsl:for-each>              
              <!-- DESCRIPTION -->
              <xsl:for-each select="md:description">
                <span>
					<xsl:attribute name="lang"><xsl:value-of select="@xml:lang"/></xsl:attribute>
					&nbsp;* <xsl:value-of select="." />
				</span>
                  <![CDATA[<br />]]>
                  <br />
              </xsl:for-each>              
              <!-- OUTPUTS -->
              <xsl:if test="cr:outputs">
                <xsl:apply-templates select="cr:outputs"/>
              </xsl:if>
              &nbsp;* <br  />
            </xsl:for-each>
          </xsl:if>          
          &nbsp;*/ 
          <!-- end of code comment -->
        </div>
        public class 
        <xsl:choose>
		    <xsl:when test="/cr:interface/md:code-name">
		    	<xsl:value-of select="/cr:interface/md:code-name"/>
		    </xsl:when>
		    <xsl:otherwise>
            	YourInterface
            </xsl:otherwise>
    	</xsl:choose> {<br /> 
    	<!-- DECLARE TEMP TYPEDEF -->
    	<xsl:call-template name="build_typedef" />    
        <!-- DECLARE TYPES -->
        <xsl:if test="/cr:interface/cr:typedefs">
          <p class="tab">
            <xsl:for-each select="/cr:interface/cr:typedefs/*">
              <xsl:choose>
                
                <!-- STRING -->
                <xsl:when test="local-name()='string'">
                  <p class="tab_no_space"> <br />
                    /** <br />
                    *
                    <![CDATA[<b>]]>
                    <xsl:call-template name="get_type_codename"/>
                    <![CDATA[</b><br />]]>
                    <br />
                    <!-- KNOWN-VALUES -->  
		            <xsl:if test="md:known-value">            
			            <![CDATA[* <table>]]>
							<xsl:apply-templates select="md:known-value"/>
						<![CDATA[</table>]]>
			            <br />
		            </xsl:if>
                    * 
                    <!-- DESCRIPTION -->
                    <xsl:for-each select="md:description">
                        <span>
							<xsl:attribute name="lang"><xsl:value-of select="@xml:lang"/></xsl:attribute>
							<xsl:value-of select="." />
						</span>
                        <![CDATA[<br />]]>
                    </xsl:for-each>
                    <br />
                    */ <br />
                    <!-- TYPENAME CODE-NAME --> 
                    public static final DOFType <xsl:call-template name="get_type_codename"/> = new DOFString.Type(<xsl:value-of select="@encoding"/>, <xsl:value-of select="@length"/>);<br />
                  </p>
                </xsl:when>
                
                <!-- BLOB -->
                <xsl:when test="local-name()='blob'">
                  <p class="tab_no_space"> <br />
                    /** <br />
                    *
                    <![CDATA[<b>]]>
                    <xsl:call-template name="get_type_codename"/>
                    <![CDATA[</b><br />]]>
                    <br />
                    <!-- KNOWN-VALUES -->  
		            <xsl:if test="md:known-value">            
			            <![CDATA[
			            <ul>
			             <li>
							<table>
						]]>
							<xsl:apply-templates select="md:known-value"/>
						<![CDATA[
							</table> 
						  </li>
						 </ul>
						]]>
			            <![CDATA[<ul>]]>
			            <br />
		            </xsl:if>
                    * 
                    <!-- DESCRIPTION -->
                    <xsl:for-each select="md:description">
                        <span>
							<xsl:attribute name="lang"><xsl:value-of select="@xml:lang"/></xsl:attribute>
							<xsl:value-of select="." />
						</span>
                        <![CDATA[<br />]]>
                    </xsl:for-each>
                    <br />
                    */ <br />
                    <!-- TYPENAME CODE-NAME --> 
                    public static final DOFType <xsl:call-template name="get_type_codename"/> = new DOFBlob.Type(
                    <xsl:if test="@min-length">
                    	<xsl:value-of select="@min-length"/>,&nbsp; 
                    </xsl:if>
                     <xsl:value-of select="@length"/> );<br />
                  </p>
                </xsl:when>
                
                <!-- uint8 -->
                <xsl:when test="local-name()='uint8'">
                  <p class="tab_no_space"> <br />
                    /** <br />
                    *
                    <![CDATA[<b>]]>
                    <xsl:call-template name="get_type_codename"/>
                    <![CDATA[</b><br />]]>
                    <br />
                    <!-- KNOWN-VALUES -->  
		            <xsl:if test="md:known-value">            
			            <![CDATA[* <table>]]>
							<xsl:apply-templates select="md:known-value"/>
						<![CDATA[</table>]]>
			            <br />
		            </xsl:if>
                    * 
                    <!-- DESCRIPTION -->
                    <xsl:for-each select="md:description">
                        <span>
							<xsl:attribute name="lang"><xsl:value-of select="@xml:lang"/></xsl:attribute>
							<xsl:value-of select="." />
						</span>
                        <![CDATA[<br />]]>
                    </xsl:for-each>
                    <br />
                    */ <br />
                    <!-- TYPENAME CODE-NAME --> 
                    public static final DOFType <xsl:call-template name="get_type_codename"/> = DOFUInt8.TYPE;<br />
                  </p>
                </xsl:when>
                
                <!-- uint16 -->
                <xsl:when test="local-name()='uint16'">
                  <p class="tab_no_space"> <br />
                    /** <br />
                    *
                    <!-- CODE-NAME -->
                    <![CDATA[<b>]]>
                    <xsl:call-template name="get_type_codename"/>
                    <![CDATA[</b><br />]]>
                    <br />
                    <!-- KNOWN-VALUES -->  
		            <xsl:if test="md:known-value">            
			            <![CDATA[* <table>]]>
							<xsl:apply-templates select="md:known-value"/>
						<![CDATA[</table>]]>
			            <br />
		            </xsl:if>
                    * 
                    <!-- DESCRIPTION -->
                    <xsl:for-each select="md:description">
                        <span>
							<xsl:attribute name="lang"><xsl:value-of select="@xml:lang"/></xsl:attribute>
							<xsl:value-of select="." />
						</span>
                        <![CDATA[<br />]]>
                    </xsl:for-each>
                    <br />
                    */ <br />
                    <!-- TYPENAME CODE-NAME --> 
                    public static final DOFType <xsl:call-template name="get_type_codename"/> = DOFUInt16.TYPE;<br />
                  </p>
                </xsl:when>
                
                <!-- uint32 -->
                <xsl:when test="local-name()='uint32'">
                  <p class="tab_no_space"> <br />
                    /** <br />
                    *
                    <![CDATA[<b>]]>
                    <xsl:call-template name="get_type_codename"/>
                    <![CDATA[</b><br />]]>
                    <br />
                    <!-- KNOWN-VALUES -->  
		            <xsl:if test="md:known-value">            
			            <![CDATA[* <table>]]>
							<xsl:apply-templates select="md:known-value"/>
						<![CDATA[</table>]]>
			            <br />
		            </xsl:if>
                    * 
                    <!-- DESCRIPTION -->
                    <xsl:for-each select="md:description">
                        <span>
							<xsl:attribute name="lang"><xsl:value-of select="@xml:lang"/></xsl:attribute>
							<xsl:value-of select="." />
						</span>
                        <![CDATA[<br />]]>
                    </xsl:for-each>
                    <br />
                    */ <br />
                    <!-- TYPENAME CODE-NAME --> 
                    public static final DOFType <xsl:call-template name="get_type_codename"/> = DOFUInt32.TYPE;<br />
                  </p>
                </xsl:when>
                
                <!-- uint64 -->
                <xsl:when test="local-name()='uint64'">
                  <p class="tab_no_space"> <br />
                    /** <br />
                    *
                    <![CDATA[<b>]]>
                    <xsl:call-template name="get_type_codename"/>
                    <![CDATA[</b><br />]]>
                    <br />
                    <!-- KNOWN-VALUES -->  
		            <xsl:if test="md:known-value">            
			            <![CDATA[* <table>]]>
							<xsl:apply-templates select="md:known-value"/>
						<![CDATA[</table>]]>
			            <br />
		            </xsl:if>
                    * 
                    <!-- DESCRIPTION -->
                    <xsl:for-each select="md:description">
                        <span>
							<xsl:attribute name="lang"><xsl:value-of select="@xml:lang"/></xsl:attribute>
							<xsl:value-of select="." />
						</span>
                        <![CDATA[<br />]]>
                    </xsl:for-each>
                    <br />
                    */ <br />
                    <!-- TYPENAME CODE-NAME --> 
                    public static final DOFType <xsl:call-template name="get_type_codename"/> = DOFUInt64.TYPE;<br />
                  </p>
                </xsl:when>
                
                <!-- int8 -->
                <xsl:when test="local-name()='int8'">
                  <p class="tab_no_space"> <br />
                    /** <br />
                    *
                    <![CDATA[<b>]]>
                    <xsl:call-template name="get_type_codename"/>
                    <![CDATA[</b><br />]]>
                    <br />
                    <!-- KNOWN-VALUES -->  
		            <xsl:if test="md:known-value">            
			            <![CDATA[* <table>]]>
							<xsl:apply-templates select="md:known-value"/>
						<![CDATA[</table>]]>
			            <br />
		            </xsl:if>
                    * 
                    <!-- DESCRIPTION -->
                    <xsl:for-each select="md:description">
                        <span>
							<xsl:attribute name="lang"><xsl:value-of select="@xml:lang"/></xsl:attribute>
							<xsl:value-of select="." />
						</span>
                        <![CDATA[<br />]]>
                    </xsl:for-each>
                    <br />
                    */ <br />
                    <!-- TYPENAME CODE-NAME --> 
                    public static final DOFType <xsl:call-template name="get_type_codename"/> = DOFInt8.TYPE;<br />
                  </p>
                </xsl:when>
                
                <!-- int16 -->
                <xsl:when test="local-name()='int16'">
                  <p class="tab_no_space"> <br />
                    /** <br />
                    *
                    <![CDATA[<b>]]>
                    <xsl:call-template name="get_type_codename"/>
                    <![CDATA[</b><br />]]>
                    <br />
                    <!-- KNOWN-VALUES -->  
		            <xsl:if test="md:known-value">            
			            <![CDATA[* <table>]]>
							<xsl:apply-templates select="md:known-value"/>
						<![CDATA[</table>]]>
			            <br />
		            </xsl:if>
                    * 
                    <!-- DESCRIPTION -->
                    <xsl:for-each select="md:description">
                        <span>
							<xsl:attribute name="lang"><xsl:value-of select="@xml:lang"/></xsl:attribute>
							<xsl:value-of select="." />
						</span>
                        <![CDATA[<br />]]>
                    </xsl:for-each>
                    <br />
                    */ <br />
                    <!-- TYPENAME CODE-NAME --> 
                    public static final DOFType <xsl:call-template name="get_type_codename"/> = DOFInt16.TYPE;<br />
                  </p>
                </xsl:when>
                
                <!-- int32 -->
                <xsl:when test="local-name()='int32'">
                  <p class="tab_no_space"> <br />
                    /** <br />
                    *
                    <![CDATA[<b>]]>
                    <xsl:call-template name="get_type_codename"/>
                    <![CDATA[</b><br />]]>
                    <br />
                    <!-- KNOWN-VALUES -->  
		            <xsl:if test="md:known-value">            
			            <![CDATA[* <table>]]>
							<xsl:apply-templates select="md:known-value"/>
						<![CDATA[</table>]]>
			            <br />
		            </xsl:if>
                    * 
                    <!-- DESCRIPTION -->
                    <xsl:for-each select="md:description">
                        <span>
							<xsl:attribute name="lang"><xsl:value-of select="@xml:lang"/></xsl:attribute>
							<xsl:value-of select="." />
						</span>
                        <![CDATA[<br />]]>
                    </xsl:for-each>
                    <br />
                    */ <br />
                    <!-- TYPENAME CODE-NAME --> 
                    public static final DOFType <xsl:call-template name="get_type_codename"/> = DOFInt32.TYPE;<br />
                  </p>
                </xsl:when>
                
                <!-- int64 -->
                <xsl:when test="local-name()='int64'">
                  <p class="tab_no_space"> <br />
                    /** <br />
                    *
                    <![CDATA[<b>]]>
                    <xsl:call-template name="get_type_codename"/>
                    <![CDATA[</b><br />]]>
                    <br />
                    <!-- KNOWN-VALUES -->  
		            <xsl:if test="md:known-value">            
			            <![CDATA[* <table>]]>
							<xsl:apply-templates select="md:known-value"/>
						<![CDATA[</table>]]>
			            <br />
		            </xsl:if>
                    * 
                    <!-- DESCRIPTION -->
                    <xsl:for-each select="md:description">
                        <span>
							<xsl:attribute name="lang"><xsl:value-of select="@xml:lang"/></xsl:attribute>
							<xsl:value-of select="." />
						</span>
                        <![CDATA[<br />]]>
                    </xsl:for-each>
                    <br />
                    */ <br />
                    <!-- TYPENAME CODE-NAME --> 
                    public static final DOFType <xsl:call-template name="get_type_codename"/> = DOFInt64.TYPE;<br />
                  </p>
                </xsl:when>
                
                <!-- float32 -->
                <xsl:when test="local-name()='float32'">
                  <p class="tab_no_space"> <br />
                    /** <br />
                    *
                    <![CDATA[<b>]]>
                    <xsl:call-template name="get_type_codename"/>
                    <![CDATA[</b><br />]]>
                    <br />
                    <!-- KNOWN-VALUES -->  
		            <xsl:if test="md:known-value">            
			            <![CDATA[* <table>]]>
							<xsl:apply-templates select="md:known-value"/>
						<![CDATA[</table>]]>
			            <br />
		            </xsl:if>
                    * 
                    <!-- DESCRIPTION -->
                    <xsl:for-each select="md:description">
                        <span>
							<xsl:attribute name="lang"><xsl:value-of select="@xml:lang"/></xsl:attribute>
							<xsl:value-of select="." />
						</span>
                        <![CDATA[<br />]]>
                    </xsl:for-each>
                    <br />
                    */ <br />
                    <!-- TYPENAME CODE-NAME --> 
                    public static final DOFType <xsl:call-template name="get_type_codename"/> = DOFFloat32.TYPE;<br />
                  </p>
                </xsl:when>
                
                <!-- float64 -->
                <xsl:when test="local-name()='float64'">
                  <p class="tab_no_space"> <br />
                    /** <br />
                    *
                    <![CDATA[<b>]]>
                    <xsl:call-template name="get_type_codename"/>
                    <![CDATA[</b><br />]]>
                    <br />
                    <!-- KNOWN-VALUES -->  
		            <xsl:if test="md:known-value">            
			            <![CDATA[* <table>]]>
							<xsl:apply-templates select="md:known-value"/>
						<![CDATA[</table>]]>
			            <br />
		            </xsl:if>
                    * 
                    <!-- DESCRIPTION -->
                    <xsl:for-each select="md:description">
                        <span>
							<xsl:attribute name="lang"><xsl:value-of select="@xml:lang"/></xsl:attribute>
							<xsl:value-of select="." />
						</span>
                        <![CDATA[<br />]]>
                    </xsl:for-each>
                    <br />
                    */ <br />
                    <!-- TYPENAME CODE-NAME --> 
                    public static final DOFType <xsl:call-template name="get_type_codename"/> = DOFFloat64.TYPE;<br />
                  </p>
                </xsl:when>
                
                <!-- DATETIME -->
                <xsl:when test="local-name()='datetime'">
                  <p class="tab_no_space"> <br />
                    /** <br />
                    *
                    <![CDATA[<b>]]>
                    <xsl:call-template name="get_type_codename"/>
                    <![CDATA[</b><br />]]>
                    <br />
                    <!-- KNOWN-VALUES -->  
		            <xsl:if test="md:known-value">            
			            <![CDATA[* <table>]]>
							<xsl:apply-templates select="md:known-value"/>
						<![CDATA[</table>]]>
			            <br />
		            </xsl:if>
                    * 
                    <!-- DESCRIPTION -->
                    <xsl:for-each select="md:description">
                        <span>
							<xsl:attribute name="lang"><xsl:value-of select="@xml:lang"/></xsl:attribute>
							<xsl:value-of select="." />
						</span>
                        <![CDATA[<br />]]>
                    </xsl:for-each>
                    <br />
                    */ <br />
                    <!-- TYPENAME CODE-NAME --> 
                    public static final DOFType <xsl:call-template name="get_type_codename"/> = DOFDateTime.TYPE;<br />
                  </p>
                </xsl:when>
                
                <!-- UUID -->
                <xsl:when test="local-name()='uuid'">
                  <p class="tab_no_space"> <br />
                    /** <br />
                    *
                    <![CDATA[<b>]]>
                    <xsl:call-template name="get_type_codename"/>
                    <![CDATA[</b><br />]]>
                    <br />
                    <!-- KNOWN-VALUES -->  
		            <xsl:if test="md:known-value">            
			            <![CDATA[* <table>]]>
							<xsl:apply-templates select="md:known-value"/>
						<![CDATA[</table>]]>
			            <br />
		            </xsl:if>
                    * 
                    <!-- DESCRIPTION -->
                    <xsl:for-each select="md:description">
                        <span>
							<xsl:attribute name="lang"><xsl:value-of select="@xml:lang"/></xsl:attribute>
							<xsl:value-of select="." />
						</span>
                        <![CDATA[<br />]]>
                    </xsl:for-each>
                    <br />
                    */ <br />
                    <!-- TYPENAME CODE-NAME --> 
                    public static final DOFType <xsl:call-template name="get_type_codename"/> = DOFGuid.TYPE;<br />
                  </p>
                </xsl:when>
                
                <!-- BOOLEAN -->
                <xsl:when test="local-name()='boolean'">
                  <p class="tab_no_space"> <br />
                    /** <br />
                    *
                    <![CDATA[<b>]]>
                    <xsl:call-template name="get_type_codename"/>
                    <![CDATA[</b><br />]]>
                    <br />
                    <!-- KNOWN-VALUES -->  
		            <xsl:if test="md:known-value">            
			            <![CDATA[* <table>]]>
							<xsl:apply-templates select="md:known-value"/>
						<![CDATA[</table>]]>
			            <br />
		            </xsl:if>
                    * 
                    <!-- DESCRIPTION -->
                    <xsl:for-each select="md:description">
                        <span>
							<xsl:attribute name="lang"><xsl:value-of select="@xml:lang"/></xsl:attribute>
							<xsl:value-of select="." />
						</span>
                        <![CDATA[<br />]]>
                    </xsl:for-each>
                    <br />
                    */ <br />
                    <!-- TYPENAME CODE-NAME --> 
                    public static final DOFType <xsl:call-template name="get_type_codename"/> = DOFBoolean.TYPE;<br />
                  </p>
                </xsl:when>
                
                <!-- OID -->
                <xsl:when test="local-name()='oid'">
                  <p class="tab_no_space"> <br />
                    /** <br />
                    *
                    <![CDATA[<b>]]>
                    <xsl:call-template name="get_type_codename"/>
                    <![CDATA[</b><br />]]>
                    <br />
                    <!-- KNOWN-VALUES -->  
		            <xsl:if test="md:known-value">            
			            <![CDATA[* <table>]]>
							<xsl:apply-templates select="md:known-value"/>
						<![CDATA[</table>]]>
			            <br />
		            </xsl:if>
                    * 
                    <!-- DESCRIPTION -->
                    <xsl:for-each select="md:description">
                        <span>
							<xsl:attribute name="lang"><xsl:value-of select="@xml:lang"/></xsl:attribute>
							<xsl:value-of select="." />
						</span>
                        <![CDATA[<br />]]>
                    </xsl:for-each>
                    <br />
                    */ <br />
                    <!-- TYPENAME CODE-NAME --> 
                    public static final DOFType <xsl:call-template name="get_type_codename"/> = DOFObjectID.TYPE;<br />
                  </p>
                </xsl:when>
                
                <!-- IID -->
                <xsl:when test="local-name()='iid'">
                  <p class="tab_no_space"> <br />
                    /** <br />
                    *
                    <![CDATA[<b>]]>
                    <xsl:call-template name="get_type_codename"/>
                    <![CDATA[</b><br />]]>
                    <br />
                    <!-- KNOWN-VALUES -->  
		            <xsl:if test="md:known-value">            
			            <![CDATA[* <table>]]>
							<xsl:apply-templates select="md:known-value"/>
						<![CDATA[</table>]]>
			            <br />
		            </xsl:if>
                    * 
                    <!-- DESCRIPTION -->
                    <xsl:for-each select="md:description">
                        <span>
							<xsl:attribute name="lang"><xsl:value-of select="@xml:lang"/></xsl:attribute>
							<xsl:value-of select="." />
						</span>
                        <![CDATA[<br />]]>
                    </xsl:for-each>
                    <br />
                    */ <br />
                    <!-- TYPENAME CODE-NAME --> 
                    public static final DOFType <xsl:call-template name="get_type_codename"/> = DOFInterfaceID.TYPE;<br />
                  </p>
                </xsl:when>
                
                <!-- NULLABLE -->
                <xsl:when test="local-name()='nullable'">
                  <p class="tab_no_space"> <br />
                    /** <br />
                    *
                    <![CDATA[<b>]]>
                    <xsl:call-template name="get_type_codename"/>
                    <![CDATA[</b><br />]]>
                    <br />
                    <!-- KNOWN-VALUES -->  
		            <xsl:if test="md:known-value">            
			            <![CDATA[* <table>]]>
							<xsl:apply-templates select="md:known-value"/>
						<![CDATA[</table>]]>
			            <br />
		            </xsl:if>
                    * 
                    <!-- DESCRIPTION -->
                    <xsl:for-each select="md:description">
                        <span>
							<xsl:attribute name="lang"><xsl:value-of select="@xml:lang"/></xsl:attribute>
							<xsl:value-of select="." />
						</span>
                        <![CDATA[<br />]]>
                    </xsl:for-each>
                    <br />
                    */ <br />
                    <!-- TYPENAME CODE-NAME --> 
                    public static final DOFType <xsl:call-template name="get_type_codename"/> = new DOFType.Nullable( 
                    <!-- GET TYPE -->
					<xsl:call-template name="get_var_type"/>
                    ); </p>
                </xsl:when>
                
                <!-- REFERENCE -->
                <xsl:when test="local-name()='reference'">
                  <p class="tab_no_space"> <br />
                    /** <br />
                    *
                    <![CDATA[<b>]]>
                    <xsl:call-template name="get_type_codename"/>
                    <![CDATA[</b><br />]]>
                    <br />
                    <!-- KNOWN-VALUES -->  
		            <xsl:if test="md:known-value">            
			            <![CDATA[* <table>]]>
							<xsl:apply-templates select="md:known-value"/>
						<![CDATA[</table>]]>
			            <br />
		            </xsl:if>
                    * 
                    <!-- DESCRIPTION -->
                    <xsl:for-each select="md:description">
                        <span>
							<xsl:attribute name="lang"><xsl:value-of select="@xml:lang"/></xsl:attribute>
							<xsl:value-of select="." />
						</span>
                        <![CDATA[<br />]]>
                    </xsl:for-each>
                    <br />
                    */ <br />
                    <!-- TYPENAME CODE-NAME --> 
                    public static final DOFType <xsl:call-template name="get_type_codename"/> = new DOFType.Typedef( 
                    <!-- GET TYPE -->
                    <xsl:call-template name="get_var_type"/>
                    ); </p>
                </xsl:when>
                
                <!-- ARRAY -->
                <xsl:when test="local-name()='array'">
                  <p class="tab_no_space"> <br />
                    /** <br />
                    *
                    <![CDATA[<b>]]>
                    <xsl:call-template name="get_type_codename"/>
                    <![CDATA[</b><br />]]>
                    <br />
                    <!-- KNOWN-VALUES -->  
		            <xsl:if test="md:known-value">            
			            <![CDATA[* <table>]]>
							<xsl:apply-templates select="md:known-value"/>
						<![CDATA[</table>]]>
			            <br />
		            </xsl:if>
                    * 
                    <!-- DESCRIPTION -->
                    <xsl:for-each select="md:description">
                        <span>
							<xsl:attribute name="lang"><xsl:value-of select="@xml:lang"/></xsl:attribute>
							<xsl:value-of select="." />
						</span>
                        <![CDATA[<br />]]>
                    </xsl:for-each>
                    <br />
                    */ <br />
                    <!-- TYPENAME CODE-NAME --> 
                    public static final DOFType <xsl:call-template name="get_type_codename"/> = new DOFArray.Type( <xsl:call-template name="get_var_type"/>,&nbsp; 
                    <!-- MIN-LENGTH --> 
                    <xsl:if test="@min-length">
                    	<xsl:value-of select="@min-length"/>,&nbsp; 
                    </xsl:if>
                    <!-- LENGTH --> 
                    <xsl:value-of select="@length"/>);<br />
                  </p>
                </xsl:when>
                
                <!-- STRUCT -->
                <xsl:when test="local-name()='structure'">
                  <p class="tab_no_space"> <br />
                    /** <br />
                    *
                    <![CDATA[<b>]]>
                    <xsl:call-template name="get_type_codename"/>
                    <![CDATA[</b><br />]]>
                    <br />
                    <!-- KNOWN-VALUES -->  
		            <xsl:if test="md:known-value">            
			            <![CDATA[* <table>]]>
							<xsl:apply-templates select="md:known-value"/>
						<![CDATA[</table>]]>
			            <br />
		            </xsl:if>
                    * 
                    <!-- DESCRIPTION -->
                    <xsl:for-each select="md:description">
                        <span>
							<xsl:attribute name="lang"><xsl:value-of select="@xml:lang"/></xsl:attribute>
							<xsl:value-of select="." />
						</span>
                        <![CDATA[<br />]]>
                    </xsl:for-each>
                    <br />
                    */ <br />
                    <!-- TYPENAME CODE-NAME --> 
                    public static final DOFType <xsl:call-template name="get_type_codename"/> = new DOFStructure.Type( 
                    <!-- FIELDS -->
                    <xsl:for-each select="cr:field">
                      <!-- GET TYPE -->
                      <xsl:call-template name="get_var_type"/>
                      <xsl:if test="position() != last()">
                        ,&nbsp;
                      </xsl:if>
                    </xsl:for-each>
                    );<br />
                  </p>
                </xsl:when>
                
                <!-- TYPEDEF NOT FOUND -->
                <xsl:otherwise>
                  <p class="tab_no_space"> // Type was not found: <xsl:value-of select ="local-name()"/><br  />
                  </p>
                </xsl:otherwise>
              </xsl:choose>
            </xsl:for-each>
          </p>
        </xsl:if>
        <p class="tab_no_space"> 
          
          <!-- create interfaceID object --> 
          <br />
          /** <br />
          *
          <xsl:for-each select="/cr:interface/md:display-name">
          	<span>
				<xsl:attribute name="lang"><xsl:value-of select="@xml:lang"/></xsl:attribute>
				&nbsp;<xsl:value-of select="." />
			</span>
          </xsl:for-each>
          InterfaceID <br />
          */ <br />
          public static final DOFInterfaceID INTERFACEID = DOFInterfaceID.create("<xsl:value-of select="/cr:interface/@iid"/>");<br /><br />
          
          <!-- build defineAs -->
          <br />
          /** <br />
          * Temporary types defined here if any<br />
          */<br />
          static {<br />
    	  <xsl:call-template name="build_defineas" /> 
          }<br />  
          
          <!-- create interface object --> 
          <br />
          /** <br />
          *
          <xsl:for-each select="/cr:interface/md:display-name">
            <span>
				<xsl:attribute name="lang"><xsl:value-of select="@xml:lang"/></xsl:attribute>
				&nbsp;<xsl:value-of select="." />
			</span>
          </xsl:for-each>
          Definition <br />
          */ 
          <br />       
          public static final DOFInterface DEFINITION = new DOFInterface.Builder( INTERFACEID )
        <p class="two_tabs_no_space"> 
          <!-- PROPERTIES -->
          <xsl:if test="/cr:interface/cr:properties">
            <xsl:for-each select="/cr:interface/cr:properties/cr:property">
              &emsp;.addProperty( 
              <!-- ITEM ID --> 
              <xsl:value-of select="@item-id"/>, 
              <!-- WRITE --> 
              <xsl:value-of select="@write"/>, 
              <!-- READ --> 
              <xsl:value-of select="@read"/>, 
              <!-- GET TYPE -->
              <xsl:call-template name="get_var_type"/>
              )<br />
            </xsl:for-each>
          </xsl:if>
          
          <!-- EVENTS -->
          <xsl:if test="/cr:interface/cr:events">
            <xsl:for-each select="/cr:interface/cr:events/cr:event">
              &emsp;.addEvent( 
              <!-- ITEM ID --> 
              <xsl:value-of select="@item-id"/> 
              <!-- OUTPUTS -->
              <xsl:if test="cr:outputs">
                ,
                <xsl:for-each select="cr:outputs/cr:output">
                  <!-- GET TYPE -->
                  <xsl:call-template name="get_var_type"/>
                  <xsl:if test="position() != last()">
                    ,
                  </xsl:if>
                </xsl:for-each>
              </xsl:if>
              )<br />
            </xsl:for-each>
          </xsl:if>
          
          <!-- METHODS -->
          <xsl:if test="/cr:interface/cr:methods">
            <xsl:for-each select="/cr:interface/cr:methods/cr:method">
              &emsp;.addMethod(
              <!-- ITEM ID -->
              <xsl:value-of select="@item-id"/>
              <!-- INPUTS -->
              <xsl:if test="cr:inputs">, new DOFType[] {
                <xsl:for-each select="cr:inputs/cr:input">
                  <!-- GET TYPE -->
                  <xsl:call-template name="get_var_type"/>
                  <xsl:if test="position() != last()">
                    ,
                  </xsl:if>
                </xsl:for-each>
                }
              </xsl:if>
              <xsl:if test="not(cr:inputs)">
                , new DOFType[] {}
              </xsl:if>
              <!-- OUTPUTS -->
              <xsl:if test="cr:outputs">
                , new DOFType[] {
                <xsl:for-each select="cr:outputs/cr:output">
                  <!-- GET TYPE -->
                  <xsl:call-template name="get_var_type"/>
                  <xsl:if test="position() != last()">
                    ,
                  </xsl:if>
                </xsl:for-each>
                }
              </xsl:if>
              <xsl:if test="not(cr:outputs)">
                , new DOFType[] {}
              </xsl:if>
              )<br />
            </xsl:for-each>
          </xsl:if>
          
          <!-- EXCEPTIONS -->
          <xsl:if test="/cr:interface/cr:exceptions">
            <xsl:for-each select="/cr:interface/cr:exceptions/cr:exception">
              &emsp;.addException( 
              <!-- ITEM ID --> 
              <xsl:value-of select="@item-id"/> 
              <!-- OUTPUTS -->
              <xsl:if test="cr:outputs">
                ,
                <xsl:for-each select="cr:outputs/cr:output">
                  <!-- GET TYPE -->
                  <xsl:call-template name="get_var_type"/>
                  <xsl:if test="position() != last()">
                    ,
                  </xsl:if>
                </xsl:for-each>
              </xsl:if>
              )<br />
            </xsl:for-each>
          </xsl:if>
          &emsp;.build(); </p>
        </p>
        }<br />
        <br />
        
        <!-- end .content  --> 
      </div>
      <!--div class="footer">
        <p></p>
      </div-->
      
      <!-- end .container  --> 
    <!--/div>
    </body>
    </html-->
  </xsl:template>
  
  <!-- HELP SUB TEMPLATES -->  
  <!-- INPUTS -->
  <xsl:template match="cr:inputs">
    &nbsp;* Inputs:
    <![CDATA[<br />]]>
    <br />
    &nbsp;* <![CDATA[<ul>]]>
    <br />
    <xsl:for-each select="cr:input">
      <!-- GET TYPE -->
      &nbsp;* <![CDATA[<li>]]>
      <xsl:call-template name="get_var_type"/>
      -
      <!-- GET TYPE DESCRIPTION -->
      <xsl:variable name="var_type_input" select="@type-ref"/>
      <xsl:if test="/cr:interface/cr:typedefs/cr:*[@type-id=$var_type_input]/md:description">
        <xsl:for-each select="/cr:interface/cr:typedefs/cr:*[@type-id=$var_type_input]/md:description">
            <span>
				<xsl:attribute name="lang"><xsl:value-of select="@xml:lang"/></xsl:attribute>
				<xsl:value-of select="." />
			</span>
        </xsl:for-each>
      </xsl:if>
      <![CDATA[</li>]]>
      <br />
    </xsl:for-each>
    &nbsp;* <![CDATA[</ul>]]>
    <br />
  </xsl:template>
  
  <!-- OUTPUTS -->
  <xsl:template match="cr:outputs">
    &nbsp;* Outputs:
    <![CDATA[<br />]]>
    <br />
    &nbsp;* <![CDATA[<ul>]]>
    <br />
    <xsl:for-each select="cr:output">
      <!-- GET TYPE -->
      &nbsp;* <![CDATA[<li>]]>
      <xsl:call-template name="get_var_type"/>
      -
      <!-- GET TYPE DESCRIPTION -->
      <xsl:variable name="var_type_output" select="@type-ref"/>
      <xsl:if test="/cr:interface/cr:typedefs/cr:*[@type-id=$var_type_output]/md:description">
        <xsl:for-each select="/cr:interface/cr:typedefs/cr:*[@type-id=$var_type_output]/md:description">
            <span>
				<xsl:attribute name="lang"><xsl:value-of select="@xml:lang"/></xsl:attribute>
				<xsl:value-of select="." />
			</span>
        </xsl:for-each>
      </xsl:if>
      <![CDATA[</li>]]>
      <br />
    </xsl:for-each>
    &nbsp;* <![CDATA[</ul>]]>
    <br />
  </xsl:template>

  <!-- FIELDS ? -->
  
  <!-- KNOWN-VALUES TABLE ROWS -->
  <xsl:template match="md:known-value">
  	<![CDATA[<tr>]]>
    	<span>
        <xsl:attribute name="lang"><xsl:value-of select="@xml:lang"/></xsl:attribute>
        <![CDATA[<td>]]>
        	<xsl:value-of select="@value"/>
        <![CDATA[</td><td>]]>
        	<xsl:value-of select="." disable-output-escaping="yes"/>
        <![CDATA[</td>]]>
        </span>
    <![CDATA[</tr>]]>
  </xsl:template>
  
  <!-- CODE-NAME MISSING -->
  <xsl:template name="get_type_codename">
  	<xsl:choose>
		<xsl:when test="md:code-name">
			<xsl:value-of select="md:code-name"/>
		</xsl:when>
		<xsl:otherwise>
			<xsl:value-of select="local-name()"/>_<xsl:value-of select="@type-id"/>
		</xsl:otherwise>
	</xsl:choose>
  </xsl:template>
  
  <!-- GET VAR TYPE IF EXISTS -->
  <xsl:template name="get_var_type">
  	<!-- GET TYPE-REF -->
  	<xsl:variable name="var_type_ref" select="@type-ref"/>
  	<!-- GET TYPE OF THE PARENT FIRST TO FIND IF SELF-REFERENCING -->
  	<xsl:variable name="var_type_id_parent" select="../@type-id"/> 
  	<!-- CHECK IF ANY FOLLOWING SIBLING NODE IS REFERENCED -->
	<xsl:if test="following-sibling::*[@type-id=$var_type_ref]">
		typedef_<xsl:call-template name="get_type_codename"/>
	</xsl:if>
	<!-- HANDLE NOT YET DECLARED TYPE REFERENCES -->
	<xsl:if test="not(following-sibling::*[@type-id=$var_type_ref])">
		<xsl:for-each select="/cr:interface/cr:typedefs/cr:*[@type-id=$var_type_ref]">
	  		<xsl:if test="@type-ref">
	  			<!-- GET SUB-TYPE-REF OF ITSELF -->
		  		<xsl:variable name="var_type_ref_ref" select="@type-ref"/>
				<xsl:if test="$var_type_ref_ref!=$var_type_id_parent or not($var_type_id_parent)">
					<xsl:call-template name="get_type_codename"/>
				</xsl:if>
				<xsl:if test="$var_type_ref_ref=$var_type_id_parent">
					typedef_<xsl:call-template name="get_type_codename"/>
				</xsl:if>
			 </xsl:if>
			 <xsl:if test="not(@type-ref)">
			    	<xsl:call-template name="get_type_codename"/>	
			 </xsl:if>
		</xsl:for-each>
	</xsl:if>
  </xsl:template>

  <!-- BUILD TEMP TYPEDEF -->
  <xsl:template name="build_typedef">
  	<!-- HANDLE NOT YET DECLARED TYPE REFERENCES -->
	<xsl:for-each select="cr:interface/cr:typedefs/cr:*">
	  	<!-- GET TYPE-REF -->
	  	<xsl:variable name="var_type_ref" select="@type-ref"/>
	  	<!-- GET TYPE OF THE PARENT FIRST TO FIND IF SELF-REFERENCING -->
  	    <xsl:variable name="var_type_id_parent" select="../@type-id"/> 
	  	<!-- CHECK IF ANY FOLLOWING SIBLING NODE IS REFERENCED -->
	  	<xsl:if test="following-sibling::*[@type-id=$var_type_ref]">
	  		&emsp;&emsp;private static DOFType.Typedef typedef_<xsl:call-template name="get_type_codename"/> = new DOFType.Typedef();<br />
	  	</xsl:if>
	</xsl:for-each>
	<!-- HANDLE SELF-REFERENCED FIELDS -->
	<xsl:for-each select="cr:interface/cr:typedefs/cr:*/cr:field">
	  	<!-- GET TYPE OF THE PARENT FIRST TO FIND IF SELF-REFERENCING -->
	  	<xsl:variable name="var_type_id_parent" select="../@type-id"/> 	
	  	<!-- GET TYPE-REF OF ITSELF -->
	  	<xsl:variable name="var_type_ref" select="@type-ref"/>
		<xsl:for-each select="/cr:interface/cr:typedefs/cr:*[@type-id=$var_type_ref]">
		  	<xsl:if test="@type-ref">
		  		<!-- GET SUB-TYPE-REF OF ITSELF -->
			  	<xsl:variable name="var_type_ref_ref" select="@type-ref"/>
				<xsl:if test="$var_type_ref_ref=$var_type_id_parent">
				&emsp;&emsp;private static DOFType.Typedef typedef_<xsl:call-template name="get_type_codename"/> = new DOFType.Typedef();<br />
				</xsl:if>
			</xsl:if>
		</xsl:for-each>
	</xsl:for-each>
  </xsl:template>
  
  <!-- BUILD DEFINE-AS -->
  <xsl:template name="build_defineas">
  	<!-- HANDLE NOT YET DECLARED TYPE REFERENCES -->
  	<xsl:for-each select="cr:interface/cr:typedefs/cr:*">
	  	<!-- GET TYPE-REF -->
	  	<xsl:variable name="var_type_ref" select="@type-ref"/>
	  	<!-- GET TYPE OF THE PARENT FIRST TO FIND IF SELF-REFERENCING -->
  		<xsl:variable name="var_type_id_parent" select="../@type-id"/> 
	  	<!-- CHECK IF ANY FOLLOWING SIBLING NODE IS REFERENCED -->
	  	<xsl:if test="following-sibling::*[@type-id=$var_type_ref]">
	  		&emsp;typedef_<xsl:call-template name="get_type_codename"/>.defineAs( <xsl:call-template name="get_type_codename"/> );<br />
	  	</xsl:if>
	</xsl:for-each>
	<!-- HANDLE SELF-REFERENCED FIELDS -->
	<xsl:for-each select="cr:interface/cr:typedefs/cr:*/cr:field">
	  	<!-- GET TYPE OF THE PARENT FIRST TO FIND IF SELF-REFERENCING -->
	  	<xsl:variable name="var_type_id_parent" select="../@type-id"/> 	
	  	<!-- GET TYPE-REF OF ITSELF -->
	  	<xsl:variable name="var_type_ref" select="@type-ref"/>
		<xsl:for-each select="/cr:interface/cr:typedefs/cr:*[@type-id=$var_type_ref]">
		  	<xsl:if test="@type-ref">
		  		<!-- GET SUB-TYPE-REF OF ITSELF -->
			  	<xsl:variable name="var_type_ref_ref" select="@type-ref"/>
				<xsl:if test="$var_type_ref_ref=$var_type_id_parent">
				&emsp;typedef_<xsl:call-template name="get_type_codename"/>.defineAs( <xsl:call-template name="get_type_codename"/> );<br />
				</xsl:if>
			</xsl:if>
		</xsl:for-each>
	</xsl:for-each>	
  </xsl:template>
  
</xsl:stylesheet>