package org.opendof.tools.repository.interfaces.servlet.menu;

import org.apache.wicket.markup.html.panel.Panel;
import org.apache.wicket.protocol.http.WebSession;
import org.opendof.tools.repository.interfaces.core.AuthenticatedUser;
import org.opendof.tools.repository.interfaces.core.CoreController;
import org.opendof.tools.repository.interfaces.servlet.InterfaceRepository;
import org.opendof.tools.repository.interfaces.servlet.auth.ClientInformation;

/**
 * Created by dethington on 7/18/2017.
 */
public abstract class InterfacePanel extends Panel {

    private static final long serialVersionUID = 8624982487529238996L;

    public InterfacePanel(String id) {
        super(id);
    }

    protected ClientInformation getClientInformation() {
        return (ClientInformation) WebSession.get().getClientInfo();
    }

    protected CoreController getCore(){
        InterfaceRepository app = (InterfaceRepository) getApplication();
        return app.getCoreController();
    }

    protected AuthenticatedUser getAuthUser (){
        return new AuthenticatedUser(getClientInformation().getName(), getClientInformation().getEmail(), getClientInformation().getDescription(), null);
    }
}
