Interface Repository Web
====
***

The Interface Repository Web component provides a frontend website for the Interface Repository. Users may use it to view existing interface
definitions.

### Browse
Users may browse a list of all interface definitions in the Interface Repository. Results may be filtered by repository type, submitter,
or publish state.

### XML Translation
The Web component provides xml translations of the raw interface definitions. Translations may include HTML and runnable code in Java or other
programming languages.

### Localization
Interface definitions may contain metadata in multiple languages. Users may select which language they wish to view.

## Build Instructions
This project uses [Apache Ant](http://ant.apache.org/) and [Apache Ivy](http://ant.apache.org/ivy/) to build and resolve dependencies. In addition, 
a Java Development Kit (JDK) of 1.7 or greater is required.

To build, make sure any dependencies are available in a configured Ivy repository, and execute 'ant dist' in the root of the project (this is the 
default ant target). To publish the build to your local ivy repository (and make it available for other builds to depend on), execute 'ant publish'.

If you plan to make a complete distribution including source, you will also need to use the 'dist-src' and 'publish-src' targets.
Typically, these would be executed prior to the binary build ('dist' and 'publish' targets), since they require a clean directory.

## Installation Instructions

Installation instructions may be found [here](doc/tomcat/INSTALL.md).

##Runtime Prerequisites
A Java Runtime Environment (JRE) of 1.8 or greater is required. A Java servlet container and web server such as Tomcast is also required.

##How to Report an Issue
Issues can be reported through the issue tracking system of the OpenDOF Project at https://issue.opendof.org

Information on the process for reporting an issue can be found at https://opendof.org/report-an-issue.