Interface Repository Version 2.0 Migration
====
***

Migrating from version 1.x to 2.0 requires an update to the database schema as well as several manual steps. The Interface Repository CLI and administrator access to the database are required in order to perform the data migration.

Before starting the migration process, ensure that you have created a backup of your MySQL database. Then, do the following:

1. Migrate the MySQL database schema. Execute `/interface-repository/migration/2.0/v1tov2migration.sql` using your preferred MySQL client in order to migrate the schema to version 2.0.
2. Using the CLI, create any subrepos required for tracking identifiers for existing interfaces. For example, OpenDOF might require a subrepo for registry 1, which in turn would contain subrepos for interfaces of length 1, 2 and 4 bytes. See CLI documentation for the correct command usage.
3. Using the CLI, set the group for each interface to one of the default groups created for version 2.0. The 'anonymous' group allows public read access to the interface. The 'user' group allows authenticated users read access to the interface. The 'private' group only allows the submitter with read and write access to the interface.
4. Using the CLI, synchronize the new database tables for tracking allocated identifiers with existing interfaces. To do this, execute the following command: `irmanage interface sync`.
5. Using the CLI, set the submitter for each interface as the user that should have rights to edit the interface. If using the default JIRA authentication, the user's email should correspond with the JIRA user account. See CLI documentation for the correct command usage.